Halide 22.0.0 Halide compiler and libraries

Classes | Public Types | Public Member Functions | Static Public Member Functions | Static Public Attributes | List of all members
Halide::Runtime::Buffer< T, Dims, InClassDimStorage > Class Template Reference

A templated Buffer class that wraps halide_buffer_t and adds functionality. More...

`#include <HalideBuffer.h>`

## Classes
class | Dimension
| Read-only access to the shape. More...

## Public Types
typedef T | ElemType

## Public Member Functions
bool | owns_host_memory () const
| Does this Buffer own the host memory it refers to? More...
HALIDE_ALWAYS_INLINE Dimension | dim (int i) const
| Access the shape of the buffer. More...
int | min (int i) const
| Access to the mins, strides, extents. More...
int | extent (int i) const
int | stride (int i) const
size_t | number_of_elements () const
| The total number of elements this buffer represents. More...
int | dimensions () const
| Get the dimensionality of the buffer. More...
halide_type_t | type () const
| Get the type of the elements. More...
T * | begin () const
| A pointer to the element with the lowest address. More...
T * | end () const
| A pointer to one beyond the element with the highest address. More...
size_t | size_in_bytes () const
| The total number of bytes spanned by the data in memory. More...
void | reset ()
| Reset the Buffer to be equivalent to a default-constructed Buffer of the same static type (if any); Buffer<void> will have its runtime type reset to uint8. More...
| Buffer ()
| Buffer (const halide_buffer_t &buf, BufferDeviceOwnership ownership=BufferDeviceOwnership::Unmanaged)
| Make a Buffer from a halide_buffer_t. More...
| Buffer (const Buffer< T, Dims, InClassDimStorage > &other)
| Copy constructor. More...
template<typename T2 , int D2, int S2>
| Buffer (const Buffer< T2, D2, S2 > &other)
| Construct a Buffer from a Buffer of different dimensionality and type. More...
| Buffer (Buffer< T, Dims, InClassDimStorage > &&other) noexcept
| Move constructor. More...
template<typename T2 , int D2, int S2>
| Buffer (Buffer< T2, D2, S2 > &&other)
| Move-construct a Buffer from a Buffer of different dimensionality and type. More...
template<typename T2 , int D2, int S2>
Buffer< T, Dims, InClassDimStorage > & | operator= (const Buffer< T2, D2, S2 > &other)
| Assign from another Buffer of possibly-different dimensionality and type. More...
Buffer< T, Dims, InClassDimStorage > & | operator= (const Buffer< T, Dims, InClassDimStorage > &other)
| Standard assignment operator. More...
template<typename T2 , int D2, int S2>
Buffer< T, Dims, InClassDimStorage > & | operator= (Buffer< T2, D2, S2 > &&other)
| Move from another Buffer of possibly-different dimensionality and type. More...
Buffer< T, Dims, InClassDimStorage > & | operator= (Buffer< T, Dims, InClassDimStorage > &&other) noexcept
| Standard move-assignment operator. More...
void | check_overflow ()
| Check the product of the extents fits in memory. More...
void | allocate (void *(*allocate_fn)(size_t)=nullptr, void(*deallocate_fn)(void *)=nullptr)
| Allocate memory for this Buffer. More...
void | deallocate ()
| Drop reference to any owned host or device memory, possibly freeing it, if this buffer held the last reference to it. More...
void | device_deallocate ()
| Drop reference to any owned device memory, possibly freeing it if this buffer held the last reference to it. More...
template<typename... Args, typename = std::enable_if_t<AllInts<Args...>::value>>
| Buffer (halide_type_t t, int first, Args... rest)
| Allocate a new image of the given size with a runtime type. More...
| Buffer (int first)
| Allocate a new image of the given size. More...
template<typename... Args, typename = std::enable_if_t<AllInts<Args...>::value>>
| Buffer (int first, int second, Args... rest)
| Buffer (halide_type_t t, const std::vector< int > &sizes)
| Allocate a new image of unknown type using a vector of ints as the size. More...
| Buffer (const std::vector< int > &sizes)
| Allocate a new image of known type using a vector of ints as the size. More...
| Buffer (halide_type_t t, const std::vector< int > &sizes, const std::vector< int > &storage_order)
| Allocate a new image of unknown type using a vector of ints as the size and a vector of indices indicating the storage order for each dimension. More...
| Buffer (const std::vector< int > &sizes, const std::vector< int > &storage_order)
template<typename Array , size_t N>
| Buffer (Array(&vals)[N])
| Make an Buffer that refers to a statically sized array. More...
template<typename... Args, typename = std::enable_if_t<AllInts<Args...>::value>>
| Buffer (halide_type_t t, add_const_if_T_is_const< void > *data, int first, Args &&...rest)
| Initialize an Buffer of runtime type from a pointer and some sizes. More...
template<typename... Args, typename = std::enable_if_t<AllInts<Args...>::value>>
| Buffer (T *data, int first, Args &&...rest)
| Initialize an Buffer from a pointer and some sizes. More...
| Buffer (T *data, const std::vector< int > &sizes)
| Initialize an Buffer from a pointer and a vector of sizes. More...
| Buffer (halide_type_t t, add_const_if_T_is_const< void > *data, const std::vector< int > &sizes)
| Initialize an Buffer of runtime type from a pointer and a vector of sizes. More...
| Buffer (halide_type_t t, add_const_if_T_is_const< void > *data, int d, const halide_dimension_t *shape)
| Initialize an Buffer from a pointer to the min coordinate and an array describing the shape. More...
| Buffer (halide_type_t t, add_const_if_T_is_const< void > *data, const std::vector< halide_dimension_t > &shape)
| Initialize a Buffer from a pointer to the min coordinate and a vector describing the shape. More...
| Buffer (T *data, int d, const halide_dimension_t *shape)
| Initialize an Buffer from a pointer to the min coordinate and an array describing the shape. More...
| Buffer (T *data, const std::vector< halide_dimension_t > &shape)
| Initialize a Buffer from a pointer to the min coordinate and a vector describing the shape. More...
| ~Buffer ()
| Destructor. More...
halide_buffer_t * | raw_buffer ()
| Get a pointer to the raw halide_buffer_t this wraps. More...
const halide_buffer_t * | raw_buffer () const
| operator halide_buffer_t * ()
| Provide a cast operator to halide_buffer_t *, so that instances can be passed directly to Halide filters. More...
template<typename T2 , int D2 = Dims>
HALIDE_ALWAYS_INLINE Buffer< T2, D2, InClassDimStorage > & | as () &
| Return a typed reference to this Buffer. More...
template<typename T2 , int D2 = Dims>
HALIDE_ALWAYS_INLINE const Buffer< T2, D2, InClassDimStorage > & | as () const &
| Return a const typed reference to this Buffer. More...
template<typename T2 , int D2 = Dims>
HALIDE_ALWAYS_INLINE Buffer< T2, D2, InClassDimStorage > | as () &&
| Return an rval reference to this Buffer. More...
HALIDE_ALWAYS_INLINE Buffer< std::add_const_t< T >, Dims, InClassDimStorage > & | as_const () &
| as_const() is syntactic sugar for .as<const T>(), to avoid the need to recapitulate the type argument. More...
HALIDE_ALWAYS_INLINE const Buffer< std::add_const_t< T >, Dims, InClassDimStorage > & | as_const () const &
HALIDE_ALWAYS_INLINE Buffer< std::add_const_t< T >, Dims, InClassDimStorage > | as_const () &&
template<typename T2 = T, typename = std::enable_if_t<!std::is_const_v<T2>>>
| operator Buffer< std::add_const_t< T2 >, Dims, InClassDimStorage > & () &
| Add some syntactic sugar to allow autoconversion from Buffer<T> to Buffer<const T>& when passing arguments. More...
template<typename TVoid , typename T2 = T, typename = std::enable_if_t<std::is_same_v<TVoid, void> && !std::is_void_v<T2> && !std::is_const_v<T2>>>
| operator Buffer< TVoid, Dims, InClassDimStorage > & () &
| Add some syntactic sugar to allow autoconversion from Buffer<T> to Buffer<void>& when passing arguments. More...
template<typename TVoid , typename T2 = T, typename = std::enable_if_t<std::is_same_v<TVoid, void> && !std::is_void_v<T2> && std::is_const_v<T2>>>
| operator Buffer< const TVoid, Dims, InClassDimStorage > & () &
| Add some syntactic sugar to allow autoconversion from Buffer<const T> to Buffer<const void>& when passing arguments. More...
int | width () const
| Conventional names for the first three dimensions. More...
int | height () const
int | channels () const
int | left () const
| Conventional names for the min and max value of each dimension. More...
int | right () const
int | top () const
int | bottom () const
Buffer< not_const_T, Dims, InClassDimStorage > | copy (void *(*allocate_fn)(size_t)=nullptr, void(*deallocate_fn)(void *)=nullptr) const
| Make a new image which is a deep copy of this image. More...
Buffer< not_const_T, Dims, InClassDimStorage > | copy_to_interleaved (void *(*allocate_fn)(size_t)=nullptr, void(*deallocate_fn)(void *)=nullptr) const
| Like copy(), but the copy is created in interleaved memory layout (vs. More...
Buffer< not_const_T, Dims, InClassDimStorage > | copy_to_planar (void *(*allocate_fn)(size_t)=nullptr, void(*deallocate_fn)(void *)=nullptr) const
| Like copy(), but the copy is created in planar memory layout (vs. More...
Buffer< T, Dims, InClassDimStorage > | alias () const
| Make a copy of the Buffer which shares the underlying host and/or device allocations as the existing Buffer. More...
template<typename T2 , int D2, int S2>
void | copy_from (Buffer< T2, D2, S2 > src)
| Fill a Buffer with the values at the same coordinates in another Buffer. More...
Buffer< T, Dims, InClassDimStorage > | cropped (int d, int min, int extent) const
| Make an image that refers to a sub-range of this image along the given dimension. More...
void | crop (int d, int min, int extent)
| Crop an image in-place along the given dimension. More...
Buffer< T, Dims, InClassDimStorage > | cropped (const std::vector< std::pair< int, int > > &rect) const
| Make an image that refers to a sub-rectangle of this image along the first N dimensions. More...
void | crop (const std::vector< std::pair< int, int > > &rect)
| Crop an image in-place along the first N dimensions. More...
Buffer< T, Dims, InClassDimStorage > | translated (int d, int dx) const
| Make an image which refers to the same data with using translated coordinates in the given dimension. More...
void | translate (int d, int delta)
| Translate an image in-place along one dimension by changing how it is indexed. More...
Buffer< T, Dims, InClassDimStorage > | translated (const std::vector< int > &delta) const
| Make an image which refers to the same data translated along the first N dimensions. More...
void | translate (const std::vector< int > &delta)
| Translate an image along the first N dimensions by changing how it is indexed. More...
void | set_min (const std::vector< int > &mins)
| Set the min coordinate of an image in the first N dimensions. More...
template<typename... Args>
void | set_min (Args... args)
bool | contains (const std::vector< int > &coords) const
| Test if a given coordinate is within the bounds of an image. More...
template<typename... Args>
bool | contains (Args... args) const
Buffer< T, Dims, InClassDimStorage > | transposed (int d1, int d2) const
| Make a buffer which refers to the same data in the same layout using a swapped indexing order for the dimensions given. More...
void | transpose (int d1, int d2)
| Transpose a buffer in-place by changing how it is indexed. More...
void | transpose (const std::vector< int > &order)
| A generalized transpose: instead of swapping two dimensions, pass a vector that lists each dimension index exactly once, in the desired order. More...
Buffer< T, Dims, InClassDimStorage > | transposed (const std::vector< int > &order) const
| Make a buffer which refers to the same data in the same layout using a different ordering of the dimensions. More...
Buffer< T,(Dims==AnyDims ? AnyDims :Dims - 1)> | sliced (int d, int pos) const
| Make a lower-dimensional buffer that refers to one slice of this buffer. More...
Buffer< T,(Dims==AnyDims ? AnyDims :Dims - 1)> | sliced (int d) const
| Make a lower-dimensional buffer that refers to one slice of this buffer at the dimension's minimum. More...
void | slice (int d, int pos)
| Rewrite the buffer to refer to a single lower-dimensional slice of itself along the given dimension at the given coordinate. More...
void | slice (int d)
| Slice a buffer in-place at the dimension's minimum. More...
Buffer< T,(Dims==AnyDims ? AnyDims :Dims+1)> | embedded (int d, int pos=0) const
| Make a new buffer that views this buffer as a single slice in a higher-dimensional space. More...
void | embed (int d, int pos=0)
| Embed a buffer in-place, increasing the dimensionality. More...
void | add_dimension ()
| Add a new dimension with a min of zero and an extent of one. More...
void | add_dimension_with_stride (int s)
| Add a new dimension with a min of zero, an extent of one, and the specified stride. More...
HALIDE_ALWAYS_INLINE void | set_host_dirty (bool v=true)
| Methods for managing any GPU allocation. More...
HALIDE_ALWAYS_INLINE bool | device_dirty () const
bool | host_dirty () const
void | set_device_dirty (bool v=true)
int | copy_to_host (void *ctx=nullptr)
int | copy_to_device (const struct halide_device_interface_t *device_interface, void *ctx=nullptr)
int | device_malloc (const struct halide_device_interface_t *device_interface, void *ctx=nullptr)
int | device_free (void *ctx=nullptr)
int | device_wrap_native (const struct halide_device_interface_t *device_interface, uint64_t handle, void *ctx=nullptr)
int | device_detach_native (void *ctx=nullptr)
int | device_and_host_malloc (const struct halide_device_interface_t *device_interface, void *ctx=nullptr)
int | device_and_host_free (const struct halide_device_interface_t *device_interface, void *ctx=nullptr)
int | device_sync (void *ctx=nullptr)
bool | has_device_allocation () const
BufferDeviceOwnership | device_ownership () const
| Return the method by which the device field is managed. More...
T * | data () const
| Get a pointer to the address of the min coordinate. More...
template<typename... Args, typename = std::enable_if_t<AllInts<Args...>::value>>
HALIDE_ALWAYS_INLINE const not_void_T & | operator() (int first, Args... rest) const
| Access elements. More...
HALIDE_ALWAYS_INLINE const not_void_T & | operator() () const
HALIDE_ALWAYS_INLINE const not_void_T & | operator() (const int *pos) const
template<typename... Args, typename = std::enable_if_t<AllInts<Args...>::value>>
HALIDE_ALWAYS_INLINE not_void_T & | operator() (int first, Args... rest)
HALIDE_ALWAYS_INLINE not_void_T & | operator() ()
HALIDE_ALWAYS_INLINE not_void_T & | operator() (const int *pos)
bool | all_equal (not_void_T val) const
| Tests that all values in this buffer are equal to val. More...
Buffer< T, Dims, InClassDimStorage > & | fill (not_void_T val)
template<typename Fn , typename... Args, int N = sizeof...(Args) + 1>
HALIDE_ALWAYS_INLINE const Buffer< T, Dims, InClassDimStorage > & | for_each_value (Fn &&f, Args &&...other_buffers) const
| Call a function on every value in the buffer, and the corresponding values in some number of other buffers of the same size. More...
template<typename Fn , typename... Args, int N = sizeof...(Args) + 1>
HALIDE_ALWAYS_INLINE Buffer< T, Dims, InClassDimStorage > & | for_each_value (Fn &&f, Args &&...other_buffers)
template<typename Fn >
HALIDE_ALWAYS_INLINE const Buffer< T, Dims, InClassDimStorage > & | for_each_element (Fn &&f) const
| Call a function at each site in a buffer. More...
template<typename Fn >
HALIDE_ALWAYS_INLINE Buffer< T, Dims, InClassDimStorage > & | for_each_element (Fn &&f)
template<typename Fn , typename = std::enable_if_t<!std::is_arithmetic_v<std::decay_t<Fn>>>>
Buffer< T, Dims, InClassDimStorage > & | fill (Fn &&f)
| Fill a buffer by evaluating a callable at every site. More...
bool | is_bounds_query () const
| Check if an input buffer passed extern stage is a querying bounds. More...
void | msan_check_mem_is_initialized (bool entire=false) const
| Convenient check to verify that all of the interesting bytes in the Buffer are initialized under MSAN. More...

## Static Public Member Functions
static constexpr halide_type_t | static_halide_type ()
| Get the Halide type of T. More...
static constexpr int | static_dimensions ()
| Callers should not use the result if has_static_dimensions is false. More...
static void | set_default_allocate_fn (void *(*allocate_fn)(size_t))
static void | set_default_deallocate_fn (void(*deallocate_fn)(void *))
template<typename T2 , int D2, int S2>
static bool | can_convert_from (const Buffer< T2, D2, S2 > &other)
| Determine if a Buffer<T, Dims, InClassDimStorage> can be constructed from some other Buffer type. More...
template<typename T2 , int D2, int S2>
static void | assert_can_convert_from (const Buffer< T2, D2, S2 > &other)
| Fail an assertion at runtime or compile-time if an Buffer<T, Dims, InClassDimStorage> cannot be constructed from some other Buffer type. More...
static Buffer< void, Dims, InClassDimStorage > | make_interleaved (halide_type_t t, int width, int height, int channels)
| If you use the (x, y, c) indexing convention, then Halide Buffers are stored planar by default. More...
static Buffer< T, Dims, InClassDimStorage > | make_interleaved (int width, int height, int channels)
| If you use the (x, y, c) indexing convention, then Halide Buffers are stored planar by default. More...
static Buffer< add_const_if_T_is_const< void >, Dims, InClassDimStorage > | make_interleaved (halide_type_t t, T *data, int width, int height, int channels)
| Wrap an existing interleaved image. More...
static Buffer< T, Dims, InClassDimStorage > | make_interleaved (T *data, int width, int height, int channels)
| Wrap an existing interleaved image. More...
static Buffer< add_const_if_T_is_const< void >, Dims, InClassDimStorage > | make_scalar (halide_type_t t)
| Make a zero-dimensional Buffer. More...
static Buffer< T, Dims, InClassDimStorage > | make_scalar ()
| Make a zero-dimensional Buffer. More...
static Buffer< T, Dims, InClassDimStorage > | make_scalar (T *data)
| Make a zero-dimensional Buffer that points to non-owned, existing data. More...
template<typename T2 , int D2, int S2>
static Buffer< T, Dims, InClassDimStorage > | make_with_shape_of (Buffer< T2, D2, S2 > src, void *(*allocate_fn)(size_t)=nullptr, void(*deallocate_fn)(void *)=nullptr)
| Make a buffer with the same shape and memory nesting order as another buffer. More...

## Static Public Attributes
static constexpr bool | has_static_halide_type = !T_is_void
| True if the Halide type is not void (or const void). More...
static constexpr bool | has_static_dimensions = (Dims != AnyDims)

## Detailed Description

template<typename T = void, int Dims = AnyDims, int InClassDimStorage = (Dims == AnyDims ? 4 : std::max(Dims, 1))>
class Halide::Runtime::Buffer< T, Dims, InClassDimStorage >

A templated Buffer class that wraps halide_buffer_t and adds functionality.

When using Halide from C++, this is the preferred way to create input and output buffers. The overhead of using this class relative to a naked halide_buffer_t is minimal - it uses another ~16 bytes on the stack, and does no dynamic allocations when using it to represent existing memory of a known maximum dimensionality.

The template parameter T is the element type. For buffers where the element type is unknown, or may vary, use void or const void.

The template parameter Dims is the number of dimensions. For buffers where the dimensionality type is unknown at, or may vary, use AnyDims.

InClassDimStorage is the maximum number of dimensions that can be represented using space inside the class itself. Set it to the maximum dimensionality you expect this buffer to be. If the actual dimensionality exceeds this, heap storage is allocated to track the shape of the buffer. InClassDimStorage defaults to 4, which should cover nearly all usage.

The class optionally allocates and owns memory for the image using a shared pointer allocated with the provided allocator. If they are null, malloc and free are used. Any device-side allocation is considered as owned if and only if the host-side allocation is owned.

Examples
  tutorial/lesson_10_aot_compilation_run.cpp.

Definition at line 224 of file HalideBuffer.h.

## Member Typedef Documentation

## ◆ ElemType

template<typename T = void, int Dims = AnyDims, int InClassDimStorage = (Dims == AnyDims ? 4 : std::max(Dims, 1))>

typedef T Halide::Runtime::Buffer< T, Dims, InClassDimStorage >::ElemType

Definition at line 573 of file HalideBuffer.h.

## Constructor & Destructor Documentation

## ◆ Buffer() [1/22]

template<typename T = void, int Dims = AnyDims, int InClassDimStorage = (Dims == AnyDims ? 4 : std::max(Dims, 1))>

Halide::Runtime::Buffer< T, Dims, InClassDimStorage >::Buffer | ( |  | ) |
| inline

Definition at line 696 of file HalideBuffer.h.

References Halide::Runtime::AnyDims, and halide_buffer_t::type.

## ◆ Buffer() [2/22]

template<typename T = void, int Dims = AnyDims, int InClassDimStorage = (Dims == AnyDims ? 4 : std::max(Dims, 1))>

Halide::Runtime::Buffer< T, Dims, InClassDimStorage >::Buffer | ( | const halide_buffer_t & | buf,
|  | BufferDeviceOwnership | ownership = `BufferDeviceOwnership::Unmanaged`
| ) |  |
| inline explicit

Make a Buffer from a halide_buffer_t.

Definition at line 706 of file HalideBuffer.h.

References halide_buffer_t::type.

## ◆ Buffer() [3/22]

template<typename T = void, int Dims = AnyDims, int InClassDimStorage = (Dims == AnyDims ? 4 : std::max(Dims, 1))>

Halide::Runtime::Buffer< T, Dims, InClassDimStorage >::Buffer | ( | const Buffer< T, Dims, InClassDimStorage > & | other | ) |
| inline

Copy constructor.

Does not copy underlying data.

Definition at line 767 of file HalideBuffer.h.

## ◆ Buffer() [4/22]

template<typename T = void, int Dims = AnyDims, int InClassDimStorage = (Dims == AnyDims ? 4 : std::max(Dims, 1))>
template<typename T2 , int D2, int S2>

Halide::Runtime::Buffer< T, Dims, InClassDimStorage >::Buffer | ( | const Buffer< T2, D2, S2 > & | other | ) |
| inline

Construct a Buffer from a Buffer of different dimensionality and type.

Asserts that the type and dimensionality matches (at runtime, if one of the types is void). Note that this constructor is implicit. This, for example, lets you pass things like Buffer<T> or Buffer<const void> to functions expected Buffer<const T>.

Definition at line 782 of file HalideBuffer.h.

## ◆ Buffer() [5/22]

template<typename T = void, int Dims = AnyDims, int InClassDimStorage = (Dims == AnyDims ? 4 : std::max(Dims, 1))>

Halide::Runtime::Buffer< T, Dims, InClassDimStorage >::Buffer | ( | Buffer< T, Dims, InClassDimStorage > && | other | ) |
| inline noexcept

Move constructor.

Definition at line 792 of file HalideBuffer.h.

## ◆ Buffer() [6/22]

template<typename T = void, int Dims = AnyDims, int InClassDimStorage = (Dims == AnyDims ? 4 : std::max(Dims, 1))>
template<typename T2 , int D2, int S2>

Halide::Runtime::Buffer< T, Dims, InClassDimStorage >::Buffer | ( | Buffer< T2, D2, S2 > && | other | ) |
| inline

Move-construct a Buffer from a Buffer of different dimensionality and type.

Asserts that the types match (at runtime if one of the types is void).

Definition at line 805 of file HalideBuffer.h.

## ◆ Buffer() [7/22]

template<typename T = void, int Dims = AnyDims, int InClassDimStorage = (Dims == AnyDims ? 4 : std::max(Dims, 1))>
template<typename... Args, typename = std::enable_if_t<AllInts<Args...>::value>>

Halide::Runtime::Buffer< T, Dims, InClassDimStorage >::Buffer | ( | halide_type_t | t,
|  | int | first,
|  | Args... | rest
| ) |  |
| inline

Allocate a new image of the given size with a runtime type.

Only used when you do know what size you want but you don't know statically what type the elements are. Pass zeros to make a buffer suitable for bounds query calls.

Definition at line 977 of file HalideBuffer.h.

References Halide::Runtime::Internal::any_zero(), and halide_buffer_t::type.

## ◆ Buffer() [8/22]

template<typename T = void, int Dims = AnyDims, int InClassDimStorage = (Dims == AnyDims ? 4 : std::max(Dims, 1))>

Halide::Runtime::Buffer< T, Dims, InClassDimStorage >::Buffer | ( | int | first | ) |
| inline explicit

Allocate a new image of the given size.

Pass zeros to make a buffer suitable for bounds query calls.

Definition at line 998 of file HalideBuffer.h.

References halide_buffer_t::type.

## ◆ Buffer() [9/22]

template<typename T = void, int Dims = AnyDims, int InClassDimStorage = (Dims == AnyDims ? 4 : std::max(Dims, 1))>
template<typename... Args, typename = std::enable_if_t<AllInts<Args...>::value>>

Halide::Runtime::Buffer< T, Dims, InClassDimStorage >::Buffer | ( | int | first,
|  | int | second,
|  | Args... | rest
| ) |  |
| inline

Definition at line 1014 of file HalideBuffer.h.

References Halide::Runtime::Internal::any_zero(), and halide_buffer_t::type.

## ◆ Buffer() [10/22]

template<typename T = void, int Dims = AnyDims, int InClassDimStorage = (Dims == AnyDims ? 4 : std::max(Dims, 1))>

Halide::Runtime::Buffer< T, Dims, InClassDimStorage >::Buffer | ( | halide_type_t | t,
|  | const std::vector< int > & | sizes
| ) |  |
| inline

Allocate a new image of unknown type using a vector of ints as the size.

Definition at line 1030 of file HalideBuffer.h.

References Halide::Runtime::Internal::any_zero(), and halide_buffer_t::type.

## ◆ Buffer() [11/22]

template<typename T = void, int Dims = AnyDims, int InClassDimStorage = (Dims == AnyDims ? 4 : std::max(Dims, 1))>

Halide::Runtime::Buffer< T, Dims, InClassDimStorage >::Buffer | ( | const std::vector< int > & | sizes | ) |
| inline explicit

Allocate a new image of known type using a vector of ints as the size.

Definition at line 1045 of file HalideBuffer.h.

## ◆ Buffer() [12/22]

template<typename T = void, int Dims = AnyDims, int InClassDimStorage = (Dims == AnyDims ? 4 : std::max(Dims, 1))>

Halide::Runtime::Buffer< T, Dims, InClassDimStorage >::Buffer | ( | halide_type_t | t,
|  | const std::vector< int > & | sizes,
|  | const std::vector< int > & | storage_order
| ) |  |
| inline

Allocate a new image of unknown type using a vector of ints as the size and a vector of indices indicating the storage order for each dimension.

The length of the sizes vector and the storage-order vector must match. For instance, to allocate an interleaved RGB buffer, you would pass {2, 0, 1} for storage_order.

Definition at line 1065 of file HalideBuffer.h.

## ◆ Buffer() [13/22]

template<typename T = void, int Dims = AnyDims, int InClassDimStorage = (Dims == AnyDims ? 4 : std::max(Dims, 1))>

Halide::Runtime::Buffer< T, Dims, InClassDimStorage >::Buffer | ( | const std::vector< int > & | sizes,
|  | const std::vector< int > & | storage_order
| ) |  |
| inline

Definition at line 1070 of file HalideBuffer.h.

## ◆ Buffer() [14/22]

template<typename T = void, int Dims = AnyDims, int InClassDimStorage = (Dims == AnyDims ? 4 : std::max(Dims, 1))>
template<typename Array , size_t N>

Halide::Runtime::Buffer< T, Dims, InClassDimStorage >::Buffer | ( | Array(&) | vals[N] | ) |
| inline explicit

Make an Buffer that refers to a statically sized array.

Does not take ownership of the data, and does not set the host_dirty flag.

Definition at line 1077 of file HalideBuffer.h.

References halide_buffer_t::dimensions, halide_buffer_t::host, and halide_buffer_t::type.

## ◆ Buffer() [15/22]

template<typename T = void, int Dims = AnyDims, int InClassDimStorage = (Dims == AnyDims ? 4 : std::max(Dims, 1))>
template<typename... Args, typename = std::enable_if_t<AllInts<Args...>::value>>

Halide::Runtime::Buffer< T, Dims, InClassDimStorage >::Buffer | ( | halide_type_t | t,
|  | add_const_if_T_is_const< void > * | data,
|  | int | first,
|  | Args &&... | rest
| ) |  |
| inline explicit

Initialize an Buffer of runtime type from a pointer and some sizes.

Assumes dense row-major packing and a min coordinate of zero. Does not take ownership of the data and does not set the host_dirty flag.

Definition at line 1091 of file HalideBuffer.h.

References halide_buffer_t::host, and halide_buffer_t::type.

## ◆ Buffer() [16/22]

template<typename T = void, int Dims = AnyDims, int InClassDimStorage = (Dims == AnyDims ? 4 : std::max(Dims, 1))>
template<typename... Args, typename = std::enable_if_t<AllInts<Args...>::value>>

Halide::Runtime::Buffer< T, Dims, InClassDimStorage >::Buffer | ( | T * | data,
|  | int | first,
|  | Args &&... | rest
| ) |  |
| inline explicit

Initialize an Buffer from a pointer and some sizes.

Assumes dense row-major packing and a min coordinate of zero. Does not take ownership of the data and does not set the host_dirty flag.

Definition at line 1108 of file HalideBuffer.h.

References halide_buffer_t::host, and halide_buffer_t::type.

## ◆ Buffer() [17/22]

template<typename T = void, int Dims = AnyDims, int InClassDimStorage = (Dims == AnyDims ? 4 : std::max(Dims, 1))>

Halide::Runtime::Buffer< T, Dims, InClassDimStorage >::Buffer | ( | T * | data,
|  | const std::vector< int > & | sizes
| ) |  |
| inline explicit

Initialize an Buffer from a pointer and a vector of sizes.

Assumes dense row-major packing and a min coordinate of zero. Does not take ownership of the data and does not set the host_dirty flag.

Definition at line 1121 of file HalideBuffer.h.

References halide_buffer_t::host, and halide_buffer_t::type.

## ◆ Buffer() [18/22]

template<typename T = void, int Dims = AnyDims, int InClassDimStorage = (Dims == AnyDims ? 4 : std::max(Dims, 1))>

Halide::Runtime::Buffer< T, Dims, InClassDimStorage >::Buffer | ( | halide_type_t | t,
|  | add_const_if_T_is_const< void > * | data,
|  | const std::vector< int > & | sizes
| ) |  |
| inline explicit

Initialize an Buffer of runtime type from a pointer and a vector of sizes.

Assumes dense row-major packing and a min coordinate of zero. Does not take ownership of the data and does not set the host_dirty flag.

Definition at line 1132 of file HalideBuffer.h.

References halide_buffer_t::host, and halide_buffer_t::type.

## ◆ Buffer() [19/22]

template<typename T = void, int Dims = AnyDims, int InClassDimStorage = (Dims == AnyDims ? 4 : std::max(Dims, 1))>

Halide::Runtime::Buffer< T, Dims, InClassDimStorage >::Buffer | ( | halide_type_t | t,
|  | add_const_if_T_is_const< void > * | data,
|  | int | d,
|  | const halide_dimension_t * | shape
| ) |  |
| inline explicit

Initialize an Buffer from a pointer to the min coordinate and an array describing the shape.

Does not take ownership of the data, and does not set the host_dirty flag.

Definition at line 1145 of file HalideBuffer.h.

References halide_buffer_t::dim, halide_buffer_t::host, and halide_buffer_t::type.

## ◆ Buffer() [20/22]

template<typename T = void, int Dims = AnyDims, int InClassDimStorage = (Dims == AnyDims ? 4 : std::max(Dims, 1))>

Halide::Runtime::Buffer< T, Dims, InClassDimStorage >::Buffer | ( | halide_type_t | t,
|  | add_const_if_T_is_const< void > * | data,
|  | const std::vector< halide_dimension_t > & | shape
| ) |  |
| inline explicit

Initialize a Buffer from a pointer to the min coordinate and a vector describing the shape.

Does not take ownership of the data, and does not set the host_dirty flag.

Definition at line 1160 of file HalideBuffer.h.

## ◆ Buffer() [21/22]

template<typename T = void, int Dims = AnyDims, int InClassDimStorage = (Dims == AnyDims ? 4 : std::max(Dims, 1))>

Halide::Runtime::Buffer< T, Dims, InClassDimStorage >::Buffer | ( | T * | data,
|  | int | d,
|  | const halide_dimension_t * | shape
| ) |  |
| inline explicit

Initialize an Buffer from a pointer to the min coordinate and an array describing the shape.

Does not take ownership of the data and does not set the host_dirty flag.

Definition at line 1168 of file HalideBuffer.h.

References halide_buffer_t::dim, halide_buffer_t::host, and halide_buffer_t::type.

## ◆ Buffer() [22/22]

template<typename T = void, int Dims = AnyDims, int InClassDimStorage = (Dims == AnyDims ? 4 : std::max(Dims, 1))>

Halide::Runtime::Buffer< T, Dims, InClassDimStorage >::Buffer | ( | T * | data,
|  | const std::vector< halide_dimension_t > & | shape
| ) |  |
| inline explicit

Initialize a Buffer from a pointer to the min coordinate and a vector describing the shape.

Does not take ownership of the data, and does not set the host_dirty flag.

Definition at line 1180 of file HalideBuffer.h.

## ◆ ~Buffer()

template<typename T = void, int Dims = AnyDims, int InClassDimStorage = (Dims == AnyDims ? 4 : std::max(Dims, 1))>

Halide::Runtime::Buffer< T, Dims, InClassDimStorage >::~Buffer | ( |  | ) |
| inline

Destructor.

Will release any underlying owned allocation if this is the last reference to it. Will assert fail if there are weak references to this Buffer outstanding.

Definition at line 1187 of file HalideBuffer.h.

## Member Function Documentation

## ◆ static_halide_type()

template<typename T = void, int Dims = AnyDims, int InClassDimStorage = (Dims == AnyDims ? 4 : std::max(Dims, 1))>

static constexpr halide_type_t Halide::Runtime::Buffer< T, Dims, InClassDimStorage >::static_halide_type | ( |  | ) |
| inline static constexpr

Get the Halide type of T.

Callers should not use the result if has_static_halide_type is false.

Definition at line 267 of file HalideBuffer.h.

Referenced by Halide::Buffer< T, Dims >::static_halide_type().

## ◆ owns_host_memory()

template<typename T = void, int Dims = AnyDims, int InClassDimStorage = (Dims == AnyDims ? 4 : std::max(Dims, 1))>

bool Halide::Runtime::Buffer< T, Dims, InClassDimStorage >::owns_host_memory | ( |  | ) | const
| inline

Does this Buffer own the host memory it refers to?

Definition at line 272 of file HalideBuffer.h.

## ◆ static_dimensions()

template<typename T = void, int Dims = AnyDims, int InClassDimStorage = (Dims == AnyDims ? 4 : std::max(Dims, 1))>

static constexpr int Halide::Runtime::Buffer< T, Dims, InClassDimStorage >::static_dimensions | ( |  | ) |
| inline static constexpr

Callers should not use the result if has_static_dimensions is false.

Definition at line 280 of file HalideBuffer.h.

Referenced by Halide::Buffer< T, Dims >::static_dimensions().

## ◆ dim()

template<typename T = void, int Dims = AnyDims, int InClassDimStorage = (Dims == AnyDims ? 4 : std::max(Dims, 1))>

HALIDE_ALWAYS_INLINE Dimension Halide::Runtime::Buffer< T, Dims, InClassDimStorage >::dim | ( | int | i | ) | const
| inline

Access the shape of the buffer.

Definition at line 633 of file HalideBuffer.h.

References halide_buffer_t::dim.

Referenced by Halide::Runtime::Buffer< T, Dims, InClassDimStorage >::copy_from().

## ◆ min()

template<typename T = void, int Dims = AnyDims, int InClassDimStorage = (Dims == AnyDims ? 4 : std::max(Dims, 1))>

int Halide::Runtime::Buffer< T, Dims, InClassDimStorage >::min | ( | int | i | ) | const
| inline

Access to the mins, strides, extents.

Will be deprecated. Do not use.

Definition at line 640 of file HalideBuffer.h.

## ◆ extent()

template<typename T = void, int Dims = AnyDims, int InClassDimStorage = (Dims == AnyDims ? 4 : std::max(Dims, 1))>

int Halide::Runtime::Buffer< T, Dims, InClassDimStorage >::extent | ( | int | i | ) | const
| inline

Definition at line 643 of file HalideBuffer.h.

## ◆ stride()

template<typename T = void, int Dims = AnyDims, int InClassDimStorage = (Dims == AnyDims ? 4 : std::max(Dims, 1))>

int Halide::Runtime::Buffer< T, Dims, InClassDimStorage >::stride | ( | int | i | ) | const
| inline

Definition at line 646 of file HalideBuffer.h.

## ◆ number_of_elements()

template<typename T = void, int Dims = AnyDims, int InClassDimStorage = (Dims == AnyDims ? 4 : std::max(Dims, 1))>

size_t Halide::Runtime::Buffer< T, Dims, InClassDimStorage >::number_of_elements | ( |  | ) | const
| inline

The total number of elements this buffer represents.

Equal to the product of the extents

Definition at line 653 of file HalideBuffer.h.

## ◆ dimensions()

template<typename T = void, int Dims = AnyDims, int InClassDimStorage = (Dims == AnyDims ? 4 : std::max(Dims, 1))>

int Halide::Runtime::Buffer< T, Dims, InClassDimStorage >::dimensions | ( |  | ) | const
| inline

Get the dimensionality of the buffer.

Definition at line 658 of file HalideBuffer.h.

References halide_buffer_t::dimensions.

Referenced by Halide::Runtime::Buffer< T, Dims, InClassDimStorage >::can_convert_from(), Halide::Runtime::Buffer< T, Dims, InClassDimStorage >::copy_from(), and Halide::Runtime::Buffer< T, Dims, InClassDimStorage >::make_with_shape_of().

## ◆ type()

template<typename T = void, int Dims = AnyDims, int InClassDimStorage = (Dims == AnyDims ? 4 : std::max(Dims, 1))>

halide_type_t Halide::Runtime::Buffer< T, Dims, InClassDimStorage >::type | ( |  | ) | const
| inline

Get the type of the elements.

Definition at line 667 of file HalideBuffer.h.

References halide_buffer_t::type.

Referenced by Halide::Runtime::Buffer< T, Dims, InClassDimStorage >::can_convert_from(), and Halide::Runtime::Buffer< T, Dims, InClassDimStorage >::make_with_shape_of().

## ◆ begin()

template<typename T = void, int Dims = AnyDims, int InClassDimStorage = (Dims == AnyDims ? 4 : std::max(Dims, 1))>

T * Halide::Runtime::Buffer< T, Dims, InClassDimStorage >::begin | ( |  | ) | const
| inline

A pointer to the element with the lowest address.

If all strides are positive, equal to the host pointer.

Definition at line 673 of file HalideBuffer.h.

References halide_buffer_t::host.

## ◆ end()

template<typename T = void, int Dims = AnyDims, int InClassDimStorage = (Dims == AnyDims ? 4 : std::max(Dims, 1))>

T * Halide::Runtime::Buffer< T, Dims, InClassDimStorage >::end | ( |  | ) | const
| inline

A pointer to one beyond the element with the highest address.

Definition at line 679 of file HalideBuffer.h.

References halide_buffer_t::host.

## ◆ size_in_bytes()

template<typename T = void, int Dims = AnyDims, int InClassDimStorage = (Dims == AnyDims ? 4 : std::max(Dims, 1))>

size_t Halide::Runtime::Buffer< T, Dims, InClassDimStorage >::size_in_bytes | ( |  | ) | const
| inline

The total number of bytes spanned by the data in memory.

Definition at line 685 of file HalideBuffer.h.

## ◆ reset()

template<typename T = void, int Dims = AnyDims, int InClassDimStorage = (Dims == AnyDims ? 4 : std::max(Dims, 1))>

void Halide::Runtime::Buffer< T, Dims, InClassDimStorage >::reset | ( |  | ) |
| inline

Reset the Buffer to be equivalent to a default-constructed Buffer of the same static type (if any); Buffer<void> will have its runtime type reset to uint8.

Definition at line 692 of file HalideBuffer.h.

## ◆ set_default_allocate_fn()

template<typename T = void, int Dims = AnyDims, int InClassDimStorage = (Dims == AnyDims ? 4 : std::max(Dims, 1))>

static void Halide::Runtime::Buffer< T, Dims, InClassDimStorage >::set_default_allocate_fn | ( | void *(*)(size_t) | allocate_fn | ) |
| inline static

Definition at line 729 of file HalideBuffer.h.

References Halide::Runtime::Internal::DefaultAllocatorFns::default_allocate_fn.

## ◆ set_default_deallocate_fn()

template<typename T = void, int Dims = AnyDims, int InClassDimStorage = (Dims == AnyDims ? 4 : std::max(Dims, 1))>

static void Halide::Runtime::Buffer< T, Dims, InClassDimStorage >::set_default_deallocate_fn | ( | void(*)(void *) | deallocate_fn | ) |
| inline static

Definition at line 732 of file HalideBuffer.h.

References Halide::Runtime::Internal::DefaultAllocatorFns::default_deallocate_fn.

## ◆ can_convert_from()

template<typename T = void, int Dims = AnyDims, int InClassDimStorage = (Dims == AnyDims ? 4 : std::max(Dims, 1))>
template<typename T2 , int D2, int S2>

static bool Halide::Runtime::Buffer< T, Dims, InClassDimStorage >::can_convert_from | ( | const Buffer< T2, D2, S2 > & | other | ) |
| inline static

Determine if a Buffer<T, Dims, InClassDimStorage> can be constructed from some other Buffer type.

If this can be determined at compile time, fail with a static assert; otherwise return a boolean based on runtime typing.

Definition at line 740 of file HalideBuffer.h.

References Halide::Runtime::AnyDims, Halide::Runtime::Buffer< T, Dims, InClassDimStorage >::dimensions(), and Halide::Runtime::Buffer< T, Dims, InClassDimStorage >::type().

Referenced by Halide::Buffer< T, Dims >::can_convert_from().

## ◆ assert_can_convert_from()

template<typename T = void, int Dims = AnyDims, int InClassDimStorage = (Dims == AnyDims ? 4 : std::max(Dims, 1))>
template<typename T2 , int D2, int S2>

static void Halide::Runtime::Buffer< T, Dims, InClassDimStorage >::assert_can_convert_from | ( | const Buffer< T2, D2, S2 > & | other | ) |
| inline static

Fail an assertion at runtime or compile-time if an Buffer<T, Dims, InClassDimStorage> cannot be constructed from some other Buffer type.

Definition at line 758 of file HalideBuffer.h.

Referenced by Halide::Runtime::Buffer< T, Dims, InClassDimStorage >::as().

## ◆ operator=() [1/4]

template<typename T = void, int Dims = AnyDims, int InClassDimStorage = (Dims == AnyDims ? 4 : std::max(Dims, 1))>
template<typename T2 , int D2, int S2>

Buffer< T, Dims, InClassDimStorage > & Halide::Runtime::Buffer< T, Dims, InClassDimStorage >::operator= | ( | const Buffer< T2, D2, S2 > & | other | ) |
| inline

Assign from another Buffer of possibly-different dimensionality and type.

Asserts that the types match (at runtime if one of the types is void).

Definition at line 819 of file HalideBuffer.h.

## ◆ operator=() [2/4]

template<typename T = void, int Dims = AnyDims, int InClassDimStorage = (Dims == AnyDims ? 4 : std::max(Dims, 1))>

Buffer< T, Dims, InClassDimStorage > & Halide::Runtime::Buffer< T, Dims, InClassDimStorage >::operator= | ( | const Buffer< T, Dims, InClassDimStorage > & | other | ) |
| inline

Standard assignment operator.

Definition at line 835 of file HalideBuffer.h.

## ◆ operator=() [3/4]

template<typename T = void, int Dims = AnyDims, int InClassDimStorage = (Dims == AnyDims ? 4 : std::max(Dims, 1))>
template<typename T2 , int D2, int S2>

Buffer< T, Dims, InClassDimStorage > & Halide::Runtime::Buffer< T, Dims, InClassDimStorage >::operator= | ( | Buffer< T2, D2, S2 > && | other | ) |
| inline

Move from another Buffer of possibly-different dimensionality and type.

Asserts that the types match (at runtime if one of the types is void).

Definition at line 854 of file HalideBuffer.h.

## ◆ operator=() [4/4]

template<typename T = void, int Dims = AnyDims, int InClassDimStorage = (Dims == AnyDims ? 4 : std::max(Dims, 1))>

Buffer< T, Dims, InClassDimStorage > & Halide::Runtime::Buffer< T, Dims, InClassDimStorage >::operator= | ( | Buffer< T, Dims, InClassDimStorage > && | other | ) |
| inline noexcept

Standard move-assignment operator.

Definition at line 868 of file HalideBuffer.h.

## ◆ check_overflow()

template<typename T = void, int Dims = AnyDims, int InClassDimStorage = (Dims == AnyDims ? 4 : std::max(Dims, 1))>

void Halide::Runtime::Buffer< T, Dims, InClassDimStorage >::check_overflow | ( |  | ) |
| inline

Check the product of the extents fits in memory.

Definition at line 881 of file HalideBuffer.h.

## ◆ allocate()

template<typename T = void, int Dims = AnyDims, int InClassDimStorage = (Dims == AnyDims ? 4 : std::max(Dims, 1))>

void Halide::Runtime::Buffer< T, Dims, InClassDimStorage >::allocate | ( | void *(*)(size_t) | allocate_fn = `nullptr`,
|  | void(*)(void *) | deallocate_fn = `nullptr`
| ) |  |
| inline

Allocate memory for this Buffer.

Drops the reference to any owned memory.

Definition at line 896 of file HalideBuffer.h.

References align_up(), Halide::Runtime::Internal::DefaultAllocatorFns::default_allocate_fn, Halide::Runtime::Internal::DefaultAllocatorFns::default_deallocate_fn, free(), HALIDE_RUNTIME_BUFFER_ALLOCATION_ALIGNMENT, halide_buffer_t::host, malloc(), and Halide::Internal::max().

Referenced by Halide::Runtime::Buffer< T, Dims, InClassDimStorage >::copy_to_interleaved(), and Halide::Runtime::Buffer< T, Dims, InClassDimStorage >::copy_to_planar().

## ◆ deallocate()

template<typename T = void, int Dims = AnyDims, int InClassDimStorage = (Dims == AnyDims ? 4 : std::max(Dims, 1))>

void Halide::Runtime::Buffer< T, Dims, InClassDimStorage >::deallocate | ( |  | ) |
| inline

Drop reference to any owned host or device memory, possibly freeing it, if this buffer held the last reference to it.

Retains the shape of the buffer. Does nothing if this buffer did not allocate its own memory.

Definition at line 960 of file HalideBuffer.h.

## ◆ device_deallocate()

template<typename T = void, int Dims = AnyDims, int InClassDimStorage = (Dims == AnyDims ? 4 : std::max(Dims, 1))>

void Halide::Runtime::Buffer< T, Dims, InClassDimStorage >::device_deallocate | ( |  | ) |
| inline

Drop reference to any owned device memory, possibly freeing it if this buffer held the last reference to it.

Asserts that device_dirty is false.

Definition at line 967 of file HalideBuffer.h.

Referenced by Halide::Runtime::Buffer< T, Dims, InClassDimStorage >::cropped(), and Halide::Runtime::Buffer< T, Dims, InClassDimStorage >::sliced().

## ◆ raw_buffer() [1/2]

template<typename T = void, int Dims = AnyDims, int InClassDimStorage = (Dims == AnyDims ? 4 : std::max(Dims, 1))>

halide_buffer_t * Halide::Runtime::Buffer< T, Dims, InClassDimStorage >::raw_buffer | ( |  | ) |
| inline

Get a pointer to the raw halide_buffer_t this wraps.

Definition at line 1194 of file HalideBuffer.h.

## ◆ raw_buffer() [2/2]

template<typename T = void, int Dims = AnyDims, int InClassDimStorage = (Dims == AnyDims ? 4 : std::max(Dims, 1))>

const halide_buffer_t * Halide::Runtime::Buffer< T, Dims, InClassDimStorage >::raw_buffer | ( |  | ) | const
| inline

Definition at line 1198 of file HalideBuffer.h.

## ◆ operator halide_buffer_t *()

template<typename T = void, int Dims = AnyDims, int InClassDimStorage = (Dims == AnyDims ? 4 : std::max(Dims, 1))>

Halide::Runtime::Buffer< T, Dims, InClassDimStorage >::operator halide_buffer_t * | ( |  | ) |
| inline

Provide a cast operator to halide_buffer_t *, so that instances can be passed directly to Halide filters.

Definition at line 1205 of file HalideBuffer.h.

## ◆ as() [1/3]

template<typename T = void, int Dims = AnyDims, int InClassDimStorage = (Dims == AnyDims ? 4 : std::max(Dims, 1))>
template<typename T2 , int D2 = Dims>

HALIDE_ALWAYS_INLINE Buffer< T2, D2, InClassDimStorage > & Halide::Runtime::Buffer< T, Dims, InClassDimStorage >::as | ( |  | ) | &
| inline

Return a typed reference to this Buffer.

Useful for converting a reference to a Buffer<void> to a reference to, for example, a Buffer<const uint8_t>, or converting a Buffer<T>& to Buffer<const T>&. You can also optionally sspecify a new value for Dims; this is useful mainly for removing the dimensionality constraint on a Buffer with explicit dimensionality. Does a runtime assert if the source buffer type is void or the new dimensionality is incompatible.

Definition at line 1217 of file HalideBuffer.h.

References Halide::Runtime::Buffer< T, Dims, InClassDimStorage >::assert_can_convert_from().

## ◆ as() [2/3]

template<typename T = void, int Dims = AnyDims, int InClassDimStorage = (Dims == AnyDims ? 4 : std::max(Dims, 1))>
template<typename T2 , int D2 = Dims>

HALIDE_ALWAYS_INLINE const Buffer< T2, D2, InClassDimStorage > & Halide::Runtime::Buffer< T, Dims, InClassDimStorage >::as | ( |  | ) | const &
| inline

Return a const typed reference to this Buffer.

Useful for converting a reference to a Buffer<void> to a reference to, for example, a Buffer<const uint8_t>, or converting a Buffer<T>& to Buffer<const T>&. You can also optionally sspecify a new value for Dims; this is useful mainly for removing the dimensionality constraint on a Buffer with explicit dimensionality. Does a runtime assert if the source buffer type is void or the new dimensionality is incompatible.

Definition at line 1230 of file HalideBuffer.h.

References Halide::Runtime::Buffer< T, Dims, InClassDimStorage >::assert_can_convert_from().

## ◆ as() [3/3]

template<typename T = void, int Dims = AnyDims, int InClassDimStorage = (Dims == AnyDims ? 4 : std::max(Dims, 1))>
template<typename T2 , int D2 = Dims>

HALIDE_ALWAYS_INLINE Buffer< T2, D2, InClassDimStorage > Halide::Runtime::Buffer< T, Dims, InClassDimStorage >::as | ( |  | ) | &&
| inline

Return an rval reference to this Buffer.

Useful for converting a reference to a Buffer<void> to a reference to, for example, a Buffer<const uint8_t>, or converting a Buffer<T>& to Buffer<const T>&. You can also optionally sspecify a new value for Dims; this is useful mainly for removing the dimensionality constraint on a Buffer with explicit dimensionality. Does a runtime assert if the source buffer type is void or the new dimensionality is incompatible.

Definition at line 1243 of file HalideBuffer.h.

References Halide::Runtime::Buffer< T, Dims, InClassDimStorage >::assert_can_convert_from().

## ◆ as_const() [1/3]

template<typename T = void, int Dims = AnyDims, int InClassDimStorage = (Dims == AnyDims ? 4 : std::max(Dims, 1))>

HALIDE_ALWAYS_INLINE Buffer< std::add_const_t< T >, Dims, InClassDimStorage > & Halide::Runtime::Buffer< T, Dims, InClassDimStorage >::as_const | ( |  | ) | &
| inline

as_const() is syntactic sugar for .as<const T>(), to avoid the need to recapitulate the type argument.

Definition at line 1252 of file HalideBuffer.h.

## ◆ as_const() [2/3]

template<typename T = void, int Dims = AnyDims, int InClassDimStorage = (Dims == AnyDims ? 4 : std::max(Dims, 1))>

HALIDE_ALWAYS_INLINE const Buffer< std::add_const_t< T >, Dims, InClassDimStorage > & Halide::Runtime::Buffer< T, Dims, InClassDimStorage >::as_const | ( |  | ) | const &
| inline

Definition at line 1259 of file HalideBuffer.h.

## ◆ as_const() [3/3]

template<typename T = void, int Dims = AnyDims, int InClassDimStorage = (Dims == AnyDims ? 4 : std::max(Dims, 1))>

HALIDE_ALWAYS_INLINE Buffer< std::add_const_t< T >, Dims, InClassDimStorage > Halide::Runtime::Buffer< T, Dims, InClassDimStorage >::as_const | ( |  | ) | &&
| inline

Definition at line 1264 of file HalideBuffer.h.

## ◆ operator Buffer< std::add_const_t< T2 >, Dims, InClassDimStorage > &()

template<typename T = void, int Dims = AnyDims, int InClassDimStorage = (Dims == AnyDims ? 4 : std::max(Dims, 1))>
template<typename T2 = T, typename = std::enable_if_t<!std::is_const_v<T2>>>

Halide::Runtime::Buffer< T, Dims, InClassDimStorage >::operator Buffer< std::add_const_t< T2 >, Dims, InClassDimStorage > & | ( |  | ) | &
| inline

Add some syntactic sugar to allow autoconversion from Buffer<T> to Buffer<const T>& when passing arguments.

Definition at line 1272 of file HalideBuffer.h.

## ◆ operator Buffer< TVoid, Dims, InClassDimStorage > &()

template<typename T = void, int Dims = AnyDims, int InClassDimStorage = (Dims == AnyDims ? 4 : std::max(Dims, 1))>
template<typename TVoid , typename T2 = T, typename = std::enable_if_t<std::is_same_v<TVoid, void> && !std::is_void_v<T2> && !std::is_const_v<T2>>>

Halide::Runtime::Buffer< T, Dims, InClassDimStorage >::operator Buffer< TVoid, Dims, InClassDimStorage > & | ( |  | ) | &
| inline

Add some syntactic sugar to allow autoconversion from Buffer<T> to Buffer<void>& when passing arguments.

Definition at line 1283 of file HalideBuffer.h.

## ◆ operator Buffer< const TVoid, Dims, InClassDimStorage > &()

template<typename T = void, int Dims = AnyDims, int InClassDimStorage = (Dims == AnyDims ? 4 : std::max(Dims, 1))>
template<typename TVoid , typename T2 = T, typename = std::enable_if_t<std::is_same_v<TVoid, void> && !std::is_void_v<T2> && std::is_const_v<T2>>>

Halide::Runtime::Buffer< T, Dims, InClassDimStorage >::operator Buffer< const TVoid, Dims, InClassDimStorage > & | ( |  | ) | &
| inline

Add some syntactic sugar to allow autoconversion from Buffer<const T> to Buffer<const void>& when passing arguments.

Definition at line 1294 of file HalideBuffer.h.

## ◆ width()

template<typename T = void, int Dims = AnyDims, int InClassDimStorage = (Dims == AnyDims ? 4 : std::max(Dims, 1))>

int Halide::Runtime::Buffer< T, Dims, InClassDimStorage >::width | ( |  | ) | const
| inline

Conventional names for the first three dimensions.

Definition at line 1300 of file HalideBuffer.h.

## ◆ height()

template<typename T = void, int Dims = AnyDims, int InClassDimStorage = (Dims == AnyDims ? 4 : std::max(Dims, 1))>

int Halide::Runtime::Buffer< T, Dims, InClassDimStorage >::height | ( |  | ) | const
| inline

Definition at line 1303 of file HalideBuffer.h.

## ◆ channels()

template<typename T = void, int Dims = AnyDims, int InClassDimStorage = (Dims == AnyDims ? 4 : std::max(Dims, 1))>

int Halide::Runtime::Buffer< T, Dims, InClassDimStorage >::channels | ( |  | ) | const
| inline

Definition at line 1306 of file HalideBuffer.h.

## ◆ left()

template<typename T = void, int Dims = AnyDims, int InClassDimStorage = (Dims == AnyDims ? 4 : std::max(Dims, 1))>

int Halide::Runtime::Buffer< T, Dims, InClassDimStorage >::left | ( |  | ) | const
| inline

Conventional names for the min and max value of each dimension.

Definition at line 1313 of file HalideBuffer.h.

## ◆ right()

template<typename T = void, int Dims = AnyDims, int InClassDimStorage = (Dims == AnyDims ? 4 : std::max(Dims, 1))>

int Halide::Runtime::Buffer< T, Dims, InClassDimStorage >::right | ( |  | ) | const
| inline

Definition at line 1317 of file HalideBuffer.h.

## ◆ top()

template<typename T = void, int Dims = AnyDims, int InClassDimStorage = (Dims == AnyDims ? 4 : std::max(Dims, 1))>

int Halide::Runtime::Buffer< T, Dims, InClassDimStorage >::top | ( |  | ) | const
| inline

Definition at line 1321 of file HalideBuffer.h.

## ◆ bottom()

template<typename T = void, int Dims = AnyDims, int InClassDimStorage = (Dims == AnyDims ? 4 : std::max(Dims, 1))>

int Halide::Runtime::Buffer< T, Dims, InClassDimStorage >::bottom | ( |  | ) | const
| inline

Definition at line 1325 of file HalideBuffer.h.

## ◆ copy()

template<typename T = void, int Dims = AnyDims, int InClassDimStorage = (Dims == AnyDims ? 4 : std::max(Dims, 1))>

Buffer< not_const_T, Dims, InClassDimStorage > Halide::Runtime::Buffer< T, Dims, InClassDimStorage >::copy | ( | void *(*)(size_t) | allocate_fn = `nullptr`,
|  | void(*)(void *) | deallocate_fn = `nullptr`
| ) |  | const
| inline

Make a new image which is a deep copy of this image.

Use crop or slice followed by copy to make a copy of only a portion of the image. The new image has the same nesting order of dimensions (e.g. channels innermost), but resets the strides to the default (each stride is the product of the extents of the inner dimensions). Note that this means any strides of zero get broadcast into a non-zero stride.

Note that the returned Buffer is always of a non-const type T (ie:

    Buffer<const T>.copy() -> Buffer<T> rather than Buffer<const T>

which is always safe, since we are making a deep copy. (The caller can easily cast it back to Buffer<const T> if desired, which is always safe and free.)

Definition at line 1345 of file HalideBuffer.h.

References Halide::Runtime::Buffer< T, Dims, InClassDimStorage >::copy_from(), and Halide::Runtime::Buffer< T, Dims, InClassDimStorage >::make_with_shape_of().

## ◆ copy_to_interleaved()

template<typename T = void, int Dims = AnyDims, int InClassDimStorage = (Dims == AnyDims ? 4 : std::max(Dims, 1))>

Buffer< not_const_T, Dims, InClassDimStorage > Halide::Runtime::Buffer< T, Dims, InClassDimStorage >::copy_to_interleaved | ( | void *(*)(size_t) | allocate_fn = `nullptr`,
|  | void(*)(void *) | deallocate_fn = `nullptr`
| ) |  | const
| inline

Like copy(), but the copy is created in interleaved memory layout (vs.

keeping the same memory layout as the original). Requires that 'this' has exactly 3 dimensions.

Definition at line 1356 of file HalideBuffer.h.

References Halide::Runtime::Buffer< T, Dims, InClassDimStorage >::allocate(), Halide::Runtime::AnyDims, Halide::Runtime::Buffer< T, Dims, InClassDimStorage >::copy_from(), Halide::Runtime::Buffer< T, Dims, InClassDimStorage >::make_interleaved(), Halide::min(), and Halide::Runtime::Buffer< T, Dims, InClassDimStorage >::set_min().

## ◆ copy_to_planar()

template<typename T = void, int Dims = AnyDims, int InClassDimStorage = (Dims == AnyDims ? 4 : std::max(Dims, 1))>

Buffer< not_const_T, Dims, InClassDimStorage > Halide::Runtime::Buffer< T, Dims, InClassDimStorage >::copy_to_planar | ( | void *(*)(size_t) | allocate_fn = `nullptr`,
|  | void(*)(void *) | deallocate_fn = `nullptr`
| ) |  | const
| inline

Like copy(), but the copy is created in planar memory layout (vs.

keeping the same memory layout as the original).

Definition at line 1370 of file HalideBuffer.h.

References Halide::Runtime::Buffer< T, Dims, InClassDimStorage >::allocate(), Halide::Runtime::Buffer< T, Dims, InClassDimStorage >::copy_from(), Halide::min(), and Halide::Runtime::Buffer< T, Dims, InClassDimStorage >::set_min().

## ◆ alias()

template<typename T = void, int Dims = AnyDims, int InClassDimStorage = (Dims == AnyDims ? 4 : std::max(Dims, 1))>

Buffer< T, Dims, InClassDimStorage > Halide::Runtime::Buffer< T, Dims, InClassDimStorage >::alias | ( |  | ) | const
| inline

Make a copy of the Buffer which shares the underlying host and/or device allocations as the existing Buffer.

This is purely syntactic sugar for cases where you have a const reference to a Buffer but need a temporary non-const copy (e.g. to make a call into AOT-generated Halide code), and want a terse inline way to create a temporary.

void call_my_func(const Buffer<const uint8_t>& input) {
my_func(input.alias(), output);
}

Definition at line 1396 of file HalideBuffer.h.

## ◆ copy_from()

template<typename T = void, int Dims = AnyDims, int InClassDimStorage = (Dims == AnyDims ? 4 : std::max(Dims, 1))>
template<typename T2 , int D2, int S2>

void Halide::Runtime::Buffer< T, Dims, InClassDimStorage >::copy_from | ( | Buffer< T2, D2, S2 > | src | ) |
| inline

Fill a Buffer with the values at the same coordinates in another Buffer.

Restricts itself to coordinates contained within the intersection of the two buffers. If the two Buffers are not in the same coordinate system, you will need to translate the argument Buffer first. E.g. if you're blitting a sprite onto a framebuffer, you'll want to translate the sprite to the correct location first like so:

framebuffer.copy_from(sprite.translated({x, y}));

Definition at line 1410 of file HalideBuffer.h.

References Halide::Runtime::AnyDims, Halide::Runtime::Buffer< T, Dims, InClassDimStorage >::crop(), Halide::Runtime::Buffer< T, Dims, InClassDimStorage >::device_dirty(), Halide::Runtime::Buffer< T, Dims, InClassDimStorage >::dim(), Halide::Runtime::Buffer< T, Dims, InClassDimStorage >::dimensions(), Halide::Runtime::Buffer< T, Dims, InClassDimStorage >::for_each_value(), Halide::Runtime::Buffer< T, Dims, InClassDimStorage >::Dimension::max(), Halide::Internal::max(), Halide::Runtime::Buffer< T, Dims, InClassDimStorage >::Dimension::min(), and Halide::Internal::min().

Referenced by Halide::Runtime::Buffer< T, Dims, InClassDimStorage >::copy(), Halide::Runtime::Buffer< T, Dims, InClassDimStorage >::copy_to_interleaved(), and Halide::Runtime::Buffer< T, Dims, InClassDimStorage >::copy_to_planar().

## ◆ cropped() [1/2]

template<typename T = void, int Dims = AnyDims, int InClassDimStorage = (Dims == AnyDims ? 4 : std::max(Dims, 1))>

Buffer< T, Dims, InClassDimStorage > Halide::Runtime::Buffer< T, Dims, InClassDimStorage >::cropped | ( | int | d,
|  | int | min,
|  | int | extent
| ) |  | const
| inline

Make an image that refers to a sub-range of this image along the given dimension.

Asserts that the crop region is within the existing bounds: you cannot "crop outwards", even if you know there is valid Buffer storage (e.g. because you already cropped inwards).

Definition at line 1467 of file HalideBuffer.h.

References Halide::Runtime::Buffer< T, Dims, InClassDimStorage >::device_deallocate(), halide_buffer_t::device_interface, and Halide::min().

## ◆ crop() [1/2]

template<typename T = void, int Dims = AnyDims, int InClassDimStorage = (Dims == AnyDims ? 4 : std::max(Dims, 1))>

void Halide::Runtime::Buffer< T, Dims, InClassDimStorage >::crop | ( | int | d,
|  | int | min,
|  | int | extent
| ) |  |
| inline

Crop an image in-place along the given dimension.

This does not move any data around in memory - it just changes the min and extent of the given dimension.

Definition at line 1487 of file HalideBuffer.h.

References halide_buffer_t::device_interface, and Halide::min().

Referenced by Halide::Runtime::Buffer< T, Dims, InClassDimStorage >::copy_from().

## ◆ cropped() [2/2]

template<typename T = void, int Dims = AnyDims, int InClassDimStorage = (Dims == AnyDims ? 4 : std::max(Dims, 1))>

Buffer< T, Dims, InClassDimStorage > Halide::Runtime::Buffer< T, Dims, InClassDimStorage >::cropped | ( | const std::vector< std::pair< int, int > > & | rect | ) | const
| inline

Make an image that refers to a sub-rectangle of this image along the first N dimensions.

Asserts that the crop region is within the existing bounds. The cropped image may drop any device handle if the device_interface cannot accomplish the crop in-place.

Definition at line 1503 of file HalideBuffer.h.

References Halide::Runtime::Buffer< T, Dims, InClassDimStorage >::device_deallocate(), and halide_buffer_t::device_interface.

## ◆ crop() [2/2]

template<typename T = void, int Dims = AnyDims, int InClassDimStorage = (Dims == AnyDims ? 4 : std::max(Dims, 1))>

void Halide::Runtime::Buffer< T, Dims, InClassDimStorage >::crop | ( | const std::vector< std::pair< int, int > > & | rect | ) |
| inline

Crop an image in-place along the first N dimensions.

This does not move any data around in memory, nor does it free memory. It just rewrites the min/extent of each dimension to refer to a subregion of the same allocation.

Definition at line 1524 of file HalideBuffer.h.

References halide_buffer_t::device_interface.

## ◆ translated() [1/2]

template<typename T = void, int Dims = AnyDims, int InClassDimStorage = (Dims == AnyDims ? 4 : std::max(Dims, 1))>

Buffer< T, Dims, InClassDimStorage > Halide::Runtime::Buffer< T, Dims, InClassDimStorage >::translated | ( | int | d,
|  | int | dx
| ) |  | const
| inline

Make an image which refers to the same data with using translated coordinates in the given dimension.

Positive values move the image data to the right or down relative to the coordinate system. Drops any device handle.

Definition at line 1540 of file HalideBuffer.h.

References Halide::Runtime::Buffer< T, Dims, InClassDimStorage >::translate().

## ◆ translate() [1/2]

template<typename T = void, int Dims = AnyDims, int InClassDimStorage = (Dims == AnyDims ? 4 : std::max(Dims, 1))>

void Halide::Runtime::Buffer< T, Dims, InClassDimStorage >::translate | ( | int | d,
|  | int | delta
| ) |  |
| inline

Translate an image in-place along one dimension by changing how it is indexed.

Does not move any data around in memory.

Definition at line 1548 of file HalideBuffer.h.

References halide_buffer_t::dim, and halide_dimension_t::min.

Referenced by Halide::Runtime::Buffer< T, Dims, InClassDimStorage >::translated().

## ◆ translated() [2/2]

template<typename T = void, int Dims = AnyDims, int InClassDimStorage = (Dims == AnyDims ? 4 : std::max(Dims, 1))>

Buffer< T, Dims, InClassDimStorage > Halide::Runtime::Buffer< T, Dims, InClassDimStorage >::translated | ( | const std::vector< int > & | delta | ) | const
| inline

Make an image which refers to the same data translated along the first N dimensions.

Definition at line 1556 of file HalideBuffer.h.

References Halide::Runtime::Buffer< T, Dims, InClassDimStorage >::translate().

## ◆ translate() [2/2]

template<typename T = void, int Dims = AnyDims, int InClassDimStorage = (Dims == AnyDims ? 4 : std::max(Dims, 1))>

void Halide::Runtime::Buffer< T, Dims, InClassDimStorage >::translate | ( | const std::vector< int > & | delta | ) |
| inline

Translate an image along the first N dimensions by changing how it is indexed.

Does not move any data around in memory.

Definition at line 1564 of file HalideBuffer.h.

References Halide::Internal::max().

## ◆ set_min() [1/2]

template<typename T = void, int Dims = AnyDims, int InClassDimStorage = (Dims == AnyDims ? 4 : std::max(Dims, 1))>

void Halide::Runtime::Buffer< T, Dims, InClassDimStorage >::set_min | ( | const std::vector< int > & | mins | ) |
| inline

Set the min coordinate of an image in the first N dimensions.

Definition at line 1576 of file HalideBuffer.h.

References halide_buffer_t::dim, and halide_dimension_t::min.

Referenced by Halide::Runtime::Buffer< T, Dims, InClassDimStorage >::copy_to_interleaved(), and Halide::Runtime::Buffer< T, Dims, InClassDimStorage >::copy_to_planar().

## ◆ set_min() [2/2]

template<typename T = void, int Dims = AnyDims, int InClassDimStorage = (Dims == AnyDims ? 4 : std::max(Dims, 1))>
template<typename... Args>

void Halide::Runtime::Buffer< T, Dims, InClassDimStorage >::set_min | ( | Args... | args | ) |
| inline

Definition at line 1585 of file HalideBuffer.h.

## ◆ contains() [1/2]

template<typename T = void, int Dims = AnyDims, int InClassDimStorage = (Dims == AnyDims ? 4 : std::max(Dims, 1))>

bool Halide::Runtime::Buffer< T, Dims, InClassDimStorage >::contains | ( | const std::vector< int > & | coords | ) | const
| inline

Test if a given coordinate is within the bounds of an image.

Definition at line 1592 of file HalideBuffer.h.

References Halide::max(), and Halide::min().

## ◆ contains() [2/2]

template<typename T = void, int Dims = AnyDims, int InClassDimStorage = (Dims == AnyDims ? 4 : std::max(Dims, 1))>
template<typename... Args>

bool Halide::Runtime::Buffer< T, Dims, InClassDimStorage >::contains | ( | Args... | args | ) | const
| inline

Definition at line 1603 of file HalideBuffer.h.

## ◆ transposed() [1/2]

template<typename T = void, int Dims = AnyDims, int InClassDimStorage = (Dims == AnyDims ? 4 : std::max(Dims, 1))>

Buffer< T, Dims, InClassDimStorage > Halide::Runtime::Buffer< T, Dims, InClassDimStorage >::transposed | ( | int | d1,
|  | int | d2
| ) |  | const
| inline

Make a buffer which refers to the same data in the same layout using a swapped indexing order for the dimensions given.

So A = B.transposed(0, 1) means that A(i, j) == B(j, i), and more strongly that A.address_of(i, j) == B.address_of(j, i).

Definition at line 1612 of file HalideBuffer.h.

References Halide::Runtime::Buffer< T, Dims, InClassDimStorage >::transpose().

## ◆ transpose() [1/2]

template<typename T = void, int Dims = AnyDims, int InClassDimStorage = (Dims == AnyDims ? 4 : std::max(Dims, 1))>

void Halide::Runtime::Buffer< T, Dims, InClassDimStorage >::transpose | ( | int | d1,
|  | int | d2
| ) |  |
| inline

Transpose a buffer in-place by changing how it is indexed.

For example, transpose(0, 1) on a two-dimensional buffer means that the value referred to by coordinates (i, j) is now reached at the coordinates (j, i), and vice versa. This is done by reordering the per-dimension metadata rather than by moving data around in memory, so other views of the same memory will not see the data as having been transposed.

Definition at line 1625 of file HalideBuffer.h.

References halide_buffer_t::dim.

Referenced by Halide::Runtime::Buffer< T, Dims, InClassDimStorage >::make_interleaved(), and Halide::Runtime::Buffer< T, Dims, InClassDimStorage >::transposed().

## ◆ transpose() [2/2]

template<typename T = void, int Dims = AnyDims, int InClassDimStorage = (Dims == AnyDims ? 4 : std::max(Dims, 1))>

void Halide::Runtime::Buffer< T, Dims, InClassDimStorage >::transpose | ( | const std::vector< int > & | order | ) |
| inline

A generalized transpose: instead of swapping two dimensions, pass a vector that lists each dimension index exactly once, in the desired order.

This does not move any data around in memory

- it just permutes how it is indexed.

Definition at line 1635 of file HalideBuffer.h.

## ◆ transposed() [2/2]

template<typename T = void, int Dims = AnyDims, int InClassDimStorage = (Dims == AnyDims ? 4 : std::max(Dims, 1))>

Buffer< T, Dims, InClassDimStorage > Halide::Runtime::Buffer< T, Dims, InClassDimStorage >::transposed | ( | const std::vector< int > & | order | ) | const
| inline

Make a buffer which refers to the same data in the same layout using a different ordering of the dimensions.

Definition at line 1653 of file HalideBuffer.h.

References Halide::Runtime::Buffer< T, Dims, InClassDimStorage >::transpose().

## ◆ sliced() [1/2]

template<typename T = void, int Dims = AnyDims, int InClassDimStorage = (Dims == AnyDims ? 4 : std::max(Dims, 1))>

Buffer< T,(Dims==AnyDims ? AnyDims :Dims - 1)> Halide::Runtime::Buffer< T, Dims, InClassDimStorage >::sliced | ( | int | d,
|  | int | pos
| ) |  | const
| inline

Make a lower-dimensional buffer that refers to one slice of this buffer.

Definition at line 1662 of file HalideBuffer.h.

References Halide::Runtime::AnyDims, Halide::Runtime::Buffer< T, Dims, InClassDimStorage >::device_deallocate(), and halide_buffer_t::device_interface.

## ◆ sliced() [2/2]

template<typename T = void, int Dims = AnyDims, int InClassDimStorage = (Dims == AnyDims ? 4 : std::max(Dims, 1))>

Buffer< T,(Dims==AnyDims ? AnyDims :Dims - 1)> Halide::Runtime::Buffer< T, Dims, InClassDimStorage >::sliced | ( | int | d | ) | const
| inline

Make a lower-dimensional buffer that refers to one slice of this buffer at the dimension's minimum.

Definition at line 1683 of file HalideBuffer.h.

References Halide::Runtime::AnyDims, and Halide::min().

## ◆ slice() [1/2]

template<typename T = void, int Dims = AnyDims, int InClassDimStorage = (Dims == AnyDims ? 4 : std::max(Dims, 1))>

void Halide::Runtime::Buffer< T, Dims, InClassDimStorage >::slice | ( | int | d,
|  | int | pos
| ) |  |
| inline

Rewrite the buffer to refer to a single lower-dimensional slice of itself along the given dimension at the given coordinate.

Does not move any data around or free the original memory, so other views of the same data are unaffected. Can only be called on a Buffer with dynamic dimensionality.

Definition at line 1695 of file HalideBuffer.h.

References Halide::Runtime::AnyDims, and halide_buffer_t::device_interface.

Referenced by Halide::Runtime::Buffer< T, Dims, InClassDimStorage >::make_scalar().

## ◆ slice() [2/2]

template<typename T = void, int Dims = AnyDims, int InClassDimStorage = (Dims == AnyDims ? 4 : std::max(Dims, 1))>

void Halide::Runtime::Buffer< T, Dims, InClassDimStorage >::slice | ( | int | d | ) |
| inline

Slice a buffer in-place at the dimension's minimum.

Definition at line 1711 of file HalideBuffer.h.

References Halide::min(), and Halide::Internal::IRMatcher::slice().

## ◆ embedded()

template<typename T = void, int Dims = AnyDims, int InClassDimStorage = (Dims == AnyDims ? 4 : std::max(Dims, 1))>

Buffer< T,(Dims==AnyDims ? AnyDims :Dims+1)> Halide::Runtime::Buffer< T, Dims, InClassDimStorage >::embedded | ( | int | d,
|  | int | pos = `0`
| ) |  | const
| inline

Make a new buffer that views this buffer as a single slice in a higher-dimensional space.

The new dimension has extent one and the given min. This operation is the opposite of slice. As an example, the following condition is true:

im2 = im.embedded(1, 17);
&im(x, y, c) == &im2(x, 17, y, c);

Definition at line 1726 of file HalideBuffer.h.

References Halide::Runtime::Buffer< T, Dims, InClassDimStorage >::embed().

## ◆ embed()

template<typename T = void, int Dims = AnyDims, int InClassDimStorage = (Dims == AnyDims ? 4 : std::max(Dims, 1))>

void Halide::Runtime::Buffer< T, Dims, InClassDimStorage >::embed | ( | int | d,
|  | int | pos = `0`
| ) |  |
| inline

Embed a buffer in-place, increasing the dimensionality.

Definition at line 1734 of file HalideBuffer.h.

References Halide::Runtime::AnyDims.

Referenced by Halide::Runtime::Buffer< T, Dims, InClassDimStorage >::embedded().

## ◆ add_dimension()

template<typename T = void, int Dims = AnyDims, int InClassDimStorage = (Dims == AnyDims ? 4 : std::max(Dims, 1))>

void Halide::Runtime::Buffer< T, Dims, InClassDimStorage >::add_dimension | ( |  | ) |
| inline

Add a new dimension with a min of zero and an extent of one.

The stride is the extent of the outermost dimension times its stride. The new dimension is the last dimension. This is a special case of embed.

Definition at line 1748 of file HalideBuffer.h.

References Halide::Runtime::AnyDims, halide_buffer_t::dim, halide_buffer_t::dimensions, halide_dimension_t::extent, and halide_dimension_t::stride.

## ◆ add_dimension_with_stride()

template<typename T = void, int Dims = AnyDims, int InClassDimStorage = (Dims == AnyDims ? 4 : std::max(Dims, 1))>

void Halide::Runtime::Buffer< T, Dims, InClassDimStorage >::add_dimension_with_stride | ( | int | s | ) |
| inline

Add a new dimension with a min of zero, an extent of one, and the specified stride.

The new dimension is the last dimension. This is a special case of embed.

Definition at line 1780 of file HalideBuffer.h.

References halide_buffer_t::dim, halide_buffer_t::dimensions, and halide_dimension_t::stride.

## ◆ set_host_dirty()

template<typename T = void, int Dims = AnyDims, int InClassDimStorage = (Dims == AnyDims ? 4 : std::max(Dims, 1))>

HALIDE_ALWAYS_INLINE void Halide::Runtime::Buffer< T, Dims, InClassDimStorage >::set_host_dirty | ( | bool | v = `true` | ) |
| inline

Methods for managing any GPU allocation.

Definition at line 1790 of file HalideBuffer.h.

## ◆ device_dirty()

template<typename T = void, int Dims = AnyDims, int InClassDimStorage = (Dims == AnyDims ? 4 : std::max(Dims, 1))>

HALIDE_ALWAYS_INLINE bool Halide::Runtime::Buffer< T, Dims, InClassDimStorage >::device_dirty | ( |  | ) | const
| inline

Definition at line 1799 of file HalideBuffer.h.

Referenced by Halide::Runtime::Buffer< T, Dims, InClassDimStorage >::copy_from().

## ◆ host_dirty()

template<typename T = void, int Dims = AnyDims, int InClassDimStorage = (Dims == AnyDims ? 4 : std::max(Dims, 1))>

bool Halide::Runtime::Buffer< T, Dims, InClassDimStorage >::host_dirty | ( |  | ) | const
| inline

Definition at line 1803 of file HalideBuffer.h.

## ◆ set_device_dirty()

template<typename T = void, int Dims = AnyDims, int InClassDimStorage = (Dims == AnyDims ? 4 : std::max(Dims, 1))>

void Halide::Runtime::Buffer< T, Dims, InClassDimStorage >::set_device_dirty | ( | bool | v = `true` | ) |
| inline

Definition at line 1807 of file HalideBuffer.h.

Referenced by Halide::PyTorch::wrap_cuda().

## ◆ copy_to_host()

template<typename T = void, int Dims = AnyDims, int InClassDimStorage = (Dims == AnyDims ? 4 : std::max(Dims, 1))>

int Halide::Runtime::Buffer< T, Dims, InClassDimStorage >::copy_to_host | ( | void * | ctx = `nullptr` | ) |
| inline

Definition at line 1812 of file HalideBuffer.h.

References halide_device_interface_t::copy_to_host, halide_buffer_t::device_interface, and halide_error_code_success.

## ◆ copy_to_device()

template<typename T = void, int Dims = AnyDims, int InClassDimStorage = (Dims == AnyDims ? 4 : std::max(Dims, 1))>

int Halide::Runtime::Buffer< T, Dims, InClassDimStorage >::copy_to_device | ( | const struct halide_device_interface_t * | device_interface,
|  | void * | ctx = `nullptr`
| ) |  |
| inline

Definition at line 1819 of file HalideBuffer.h.

References halide_device_interface_t::copy_to_device, and halide_error_code_success.

## ◆ device_malloc()

template<typename T = void, int Dims = AnyDims, int InClassDimStorage = (Dims == AnyDims ? 4 : std::max(Dims, 1))>

int Halide::Runtime::Buffer< T, Dims, InClassDimStorage >::device_malloc | ( | const struct halide_device_interface_t * | device_interface,
|  | void * | ctx = `nullptr`
| ) |  |
| inline

Definition at line 1826 of file HalideBuffer.h.

References halide_device_interface_t::device_malloc.

## ◆ device_free()

template<typename T = void, int Dims = AnyDims, int InClassDimStorage = (Dims == AnyDims ? 4 : std::max(Dims, 1))>

int Halide::Runtime::Buffer< T, Dims, InClassDimStorage >::device_free | ( | void * | ctx = `nullptr` | ) |
| inline

Definition at line 1830 of file HalideBuffer.h.

References Halide::Runtime::Allocated, Halide::Runtime::DeviceRefCount::count, halide_device_interface_t::device_free, halide_buffer_t::device_interface, halide_error_code_success, and Halide::Runtime::DeviceRefCount::ownership.

## ◆ device_wrap_native()

template<typename T = void, int Dims = AnyDims, int InClassDimStorage = (Dims == AnyDims ? 4 : std::max(Dims, 1))>

int Halide::Runtime::Buffer< T, Dims, InClassDimStorage >::device_wrap_native | ( | const struct halide_device_interface_t * | device_interface,
|  | uint64_t | handle,
|  | void * | ctx = `nullptr`
| ) |  |
| inline

Definition at line 1853 of file HalideBuffer.h.

References Halide::Runtime::DeviceRefCount::ownership, halide_device_interface_t::wrap_native, and Halide::Runtime::WrappedNative.

Referenced by Halide::PyTorch::wrap_cuda().

## ◆ device_detach_native()

template<typename T = void, int Dims = AnyDims, int InClassDimStorage = (Dims == AnyDims ? 4 : std::max(Dims, 1))>

int Halide::Runtime::Buffer< T, Dims, InClassDimStorage >::device_detach_native | ( | void * | ctx = `nullptr` | ) |
| inline

Definition at line 1861 of file HalideBuffer.h.

References Halide::Runtime::DeviceRefCount::count, halide_device_interface_t::detach_native, halide_buffer_t::device_interface, halide_error_code_success, Halide::Runtime::DeviceRefCount::ownership, and Halide::Runtime::WrappedNative.

## ◆ device_and_host_malloc()

template<typename T = void, int Dims = AnyDims, int InClassDimStorage = (Dims == AnyDims ? 4 : std::max(Dims, 1))>

int Halide::Runtime::Buffer< T, Dims, InClassDimStorage >::device_and_host_malloc | ( | const struct halide_device_interface_t * | device_interface,
|  | void * | ctx = `nullptr`
| ) |  |
| inline

Definition at line 1883 of file HalideBuffer.h.

References halide_device_interface_t::device_and_host_malloc.

## ◆ device_and_host_free()

template<typename T = void, int Dims = AnyDims, int InClassDimStorage = (Dims == AnyDims ? 4 : std::max(Dims, 1))>

int Halide::Runtime::Buffer< T, Dims, InClassDimStorage >::device_and_host_free | ( | const struct halide_device_interface_t * | device_interface,
|  | void * | ctx = `nullptr`
| ) |  |
| inline

Definition at line 1887 of file HalideBuffer.h.

References Halide::Runtime::AllocatedDeviceAndHost, Halide::Runtime::DeviceRefCount::count, halide_device_interface_t::device_and_host_free, halide_buffer_t::device_interface, halide_error_code_success, and Halide::Runtime::DeviceRefCount::ownership.

## ◆ device_sync()

template<typename T = void, int Dims = AnyDims, int InClassDimStorage = (Dims == AnyDims ? 4 : std::max(Dims, 1))>

int Halide::Runtime::Buffer< T, Dims, InClassDimStorage >::device_sync | ( | void * | ctx = `nullptr` | ) |
| inline

Definition at line 1910 of file HalideBuffer.h.

## ◆ has_device_allocation()

template<typename T = void, int Dims = AnyDims, int InClassDimStorage = (Dims == AnyDims ? 4 : std::max(Dims, 1))>

bool Halide::Runtime::Buffer< T, Dims, InClassDimStorage >::has_device_allocation | ( |  | ) | const
| inline

Definition at line 1914 of file HalideBuffer.h.

References halide_buffer_t::device.

## ◆ device_ownership()

template<typename T = void, int Dims = AnyDims, int InClassDimStorage = (Dims == AnyDims ? 4 : std::max(Dims, 1))>

BufferDeviceOwnership Halide::Runtime::Buffer< T, Dims, InClassDimStorage >::device_ownership | ( |  | ) | const
| inline

Return the method by which the device field is managed.

Definition at line 1919 of file HalideBuffer.h.

References Halide::Runtime::Allocated, and Halide::Runtime::DeviceRefCount::ownership.

## ◆ make_interleaved() [1/4]

template<typename T = void, int Dims = AnyDims, int InClassDimStorage = (Dims == AnyDims ? 4 : std::max(Dims, 1))>

static Buffer< void, Dims, InClassDimStorage > Halide::Runtime::Buffer< T, Dims, InClassDimStorage >::make_interleaved | ( | halide_type_t | t,
|  | int | width,
|  | int | height,
|  | int | channels
| ) |  |
| inline static

If you use the (x, y, c) indexing convention, then Halide Buffers are stored planar by default.

This function constructs an interleaved RGB or RGBA image that can still be indexed using (x, y, c). Passing it to a generator requires that the generator has been compiled with support for interleaved (also known as packed or chunky) memory layouts.

Definition at line 1933 of file HalideBuffer.h.

References Halide::Runtime::AnyDims, and Halide::Runtime::Buffer< T, Dims, InClassDimStorage >::transpose().

Referenced by Halide::Runtime::Buffer< T, Dims, InClassDimStorage >::copy_to_interleaved().

## ◆ make_interleaved() [2/4]

template<typename T = void, int Dims = AnyDims, int InClassDimStorage = (Dims == AnyDims ? 4 : std::max(Dims, 1))>

static Buffer< T, Dims, InClassDimStorage > Halide::Runtime::Buffer< T, Dims, InClassDimStorage >::make_interleaved | ( | int | width,
|  | int | height,
|  | int | channels
| ) |  |
| inline static

If you use the (x, y, c) indexing convention, then Halide Buffers are stored planar by default.

This function constructs an interleaved RGB or RGBA image that can still be indexed using (x, y, c). Passing it to a generator requires that the generator has been compiled with support for interleaved (also known as packed or chunky) memory layouts.

Definition at line 1949 of file HalideBuffer.h.

## ◆ make_interleaved() [3/4]

template<typename T = void, int Dims = AnyDims, int InClassDimStorage = (Dims == AnyDims ? 4 : std::max(Dims, 1))>

static Buffer< add_const_if_T_is_const< void >, Dims, InClassDimStorage > Halide::Runtime::Buffer< T, Dims, InClassDimStorage >::make_interleaved | ( | halide_type_t | t,
|  | T * | data,
|  | int | width,
|  | int | height,
|  | int | channels
| ) |  |
| inline static

Wrap an existing interleaved image.

Definition at line 1955 of file HalideBuffer.h.

References Halide::Runtime::AnyDims, and Halide::Runtime::Buffer< T, Dims, InClassDimStorage >::transpose().

## ◆ make_interleaved() [4/4]

template<typename T = void, int Dims = AnyDims, int InClassDimStorage = (Dims == AnyDims ? 4 : std::max(Dims, 1))>

static Buffer< T, Dims, InClassDimStorage > Halide::Runtime::Buffer< T, Dims, InClassDimStorage >::make_interleaved | ( | T * | data,
|  | int | width,
|  | int | height,
|  | int | channels
| ) |  |
| inline static

Wrap an existing interleaved image.

Definition at line 1964 of file HalideBuffer.h.

## ◆ make_scalar() [1/3]

template<typename T = void, int Dims = AnyDims, int InClassDimStorage = (Dims == AnyDims ? 4 : std::max(Dims, 1))>

static Buffer< add_const_if_T_is_const< void >, Dims, InClassDimStorage > Halide::Runtime::Buffer< T, Dims, InClassDimStorage >::make_scalar | ( | halide_type_t | t | ) |
| inline static

Make a zero-dimensional Buffer.

Definition at line 1969 of file HalideBuffer.h.

References Halide::Runtime::AnyDims, and Halide::Runtime::Buffer< T, Dims, InClassDimStorage >::slice().

## ◆ make_scalar() [2/3]

template<typename T = void, int Dims = AnyDims, int InClassDimStorage = (Dims == AnyDims ? 4 : std::max(Dims, 1))>

static Buffer< T, Dims, InClassDimStorage > Halide::Runtime::Buffer< T, Dims, InClassDimStorage >::make_scalar | ( |  | ) |
| inline static

Make a zero-dimensional Buffer.

Definition at line 1977 of file HalideBuffer.h.

References Halide::Runtime::AnyDims, and Halide::Runtime::Buffer< T, Dims, InClassDimStorage >::slice().

Referenced by Halide::SimdOpCheckTest::check_one().

## ◆ make_scalar() [3/3]

template<typename T = void, int Dims = AnyDims, int InClassDimStorage = (Dims == AnyDims ? 4 : std::max(Dims, 1))>

static Buffer< T, Dims, InClassDimStorage > Halide::Runtime::Buffer< T, Dims, InClassDimStorage >::make_scalar | ( | T * | data | ) |
| inline static

Make a zero-dimensional Buffer that points to non-owned, existing data.

Definition at line 1985 of file HalideBuffer.h.

References Halide::Runtime::AnyDims, and Halide::Runtime::Buffer< T, Dims, InClassDimStorage >::slice().

## ◆ make_with_shape_of()

template<typename T = void, int Dims = AnyDims, int InClassDimStorage = (Dims == AnyDims ? 4 : std::max(Dims, 1))>
template<typename T2 , int D2, int S2>

static Buffer< T, Dims, InClassDimStorage > Halide::Runtime::Buffer< T, Dims, InClassDimStorage >::make_with_shape_of | ( | Buffer< T2, D2, S2 > | src,
|  | void *(*)(size_t) | allocate_fn = `nullptr`,
|  | void(*)(void *) | deallocate_fn = `nullptr`
| ) |  |
| inline static

Make a buffer with the same shape and memory nesting order as another buffer.

It may have a different type.

Definition at line 1996 of file HalideBuffer.h.

References Halide::Runtime::AnyDims, halide_buffer_t::dim, Halide::Runtime::Buffer< T, Dims, InClassDimStorage >::dimensions(), and Halide::Runtime::Buffer< T, Dims, InClassDimStorage >::type().

Referenced by Halide::Runtime::Buffer< T, Dims, InClassDimStorage >::copy().

## ◆ data()

template<typename T = void, int Dims = AnyDims, int InClassDimStorage = (Dims == AnyDims ? 4 : std::max(Dims, 1))>

T * Halide::Runtime::Buffer< T, Dims, InClassDimStorage >::data | ( |  | ) | const
| inline

Get a pointer to the address of the min coordinate.

Definition at line 2098 of file HalideBuffer.h.

References halide_buffer_t::host.

## ◆ operator()() [1/6]

template<typename T = void, int Dims = AnyDims, int InClassDimStorage = (Dims == AnyDims ? 4 : std::max(Dims, 1))>
template<typename... Args, typename = std::enable_if_t<AllInts<Args...>::value>>

HALIDE_ALWAYS_INLINE const not_void_T & Halide::Runtime::Buffer< T, Dims, InClassDimStorage >::operator() | ( | int | first,
|  | Args... | rest
| ) |  | const
| inline

Access elements.

Use im(...) to get a reference to an element, and use &im(...) to get the address of an element. If you pass fewer arguments than the buffer has dimensions, the rest are treated as their min coordinate. The non-const versions set the host_dirty flag to true.

Definition at line 2111 of file HalideBuffer.h.

References Halide::Runtime::AnyDims.

## ◆ operator()() [2/6]

template<typename T = void, int Dims = AnyDims, int InClassDimStorage = (Dims == AnyDims ? 4 : std::max(Dims, 1))>

HALIDE_ALWAYS_INLINE const not_void_T & Halide::Runtime::Buffer< T, Dims, InClassDimStorage >::operator() | ( |  | ) | const
| inline

Definition at line 2121 of file HalideBuffer.h.

References Halide::Runtime::AnyDims.

## ◆ operator()() [3/6]

template<typename T = void, int Dims = AnyDims, int InClassDimStorage = (Dims == AnyDims ? 4 : std::max(Dims, 1))>

HALIDE_ALWAYS_INLINE const not_void_T & Halide::Runtime::Buffer< T, Dims, InClassDimStorage >::operator() | ( | const int * | pos | ) | const
| inline

Definition at line 2132 of file HalideBuffer.h.

## ◆ operator()() [4/6]

template<typename T = void, int Dims = AnyDims, int InClassDimStorage = (Dims == AnyDims ? 4 : std::max(Dims, 1))>
template<typename... Args, typename = std::enable_if_t<AllInts<Args...>::value>>

HALIDE_ALWAYS_INLINE not_void_T & Halide::Runtime::Buffer< T, Dims, InClassDimStorage >::operator() | ( | int | first,
|  | Args... | rest
| ) |  |
| inline

Definition at line 2141 of file HalideBuffer.h.

References Halide::Runtime::AnyDims.

## ◆ operator()() [5/6]

template<typename T = void, int Dims = AnyDims, int InClassDimStorage = (Dims == AnyDims ? 4 : std::max(Dims, 1))>

HALIDE_ALWAYS_INLINE not_void_T & Halide::Runtime::Buffer< T, Dims, InClassDimStorage >::operator() | ( |  | ) |
| inline

Definition at line 2152 of file HalideBuffer.h.

References Halide::Runtime::AnyDims.

## ◆ operator()() [6/6]

template<typename T = void, int Dims = AnyDims, int InClassDimStorage = (Dims == AnyDims ? 4 : std::max(Dims, 1))>

HALIDE_ALWAYS_INLINE not_void_T & Halide::Runtime::Buffer< T, Dims, InClassDimStorage >::operator() | ( | const int * | pos | ) |
| inline

Definition at line 2163 of file HalideBuffer.h.

## ◆ all_equal()

template<typename T = void, int Dims = AnyDims, int InClassDimStorage = (Dims == AnyDims ? 4 : std::max(Dims, 1))>

bool Halide::Runtime::Buffer< T, Dims, InClassDimStorage >::all_equal | ( | not_void_T | val | ) | const
| inline

Tests that all values in this buffer are equal to val.

Definition at line 2172 of file HalideBuffer.h.

## ◆ fill() [1/2]

template<typename T = void, int Dims = AnyDims, int InClassDimStorage = (Dims == AnyDims ? 4 : std::max(Dims, 1))>

Buffer< T, Dims, InClassDimStorage > & Halide::Runtime::Buffer< T, Dims, InClassDimStorage >::fill | ( | not_void_T | val | ) |
| inline

Definition at line 2178 of file HalideBuffer.h.

## ◆ for_each_value() [1/2]

template<typename T = void, int Dims = AnyDims, int InClassDimStorage = (Dims == AnyDims ? 4 : std::max(Dims, 1))>
template<typename Fn , typename... Args, int N = sizeof...(Args) + 1>

HALIDE_ALWAYS_INLINE const Buffer< T, Dims, InClassDimStorage > & Halide::Runtime::Buffer< T, Dims, InClassDimStorage >::for_each_value | ( | Fn && | f,
|  | Args &&... | other_buffers
| ) |  | const
| inline

Call a function on every value in the buffer, and the corresponding values in some number of other buffers of the same size.

The function should take a reference, const reference, or value of the correct type for each buffer. This effectively lifts a function of scalars to an element-wise function of buffers. This produces code that the compiler can autovectorize. This is slightly cheaper than for_each_element, because it does not need to track the coordinates.

Note that constness of Buffers is preserved: a const Buffer<T> (for either 'this' or the other-buffers arguments) will allow mutation of the buffer contents, while a Buffer<const T> will not. Attempting to specify a mutable reference for the lambda argument of a Buffer<const T> will result in a compilation error.

Definition at line 2339 of file HalideBuffer.h.

Referenced by Halide::Runtime::Buffer< T, Dims, InClassDimStorage >::copy_from().

## ◆ for_each_value() [2/2]

template<typename T = void, int Dims = AnyDims, int InClassDimStorage = (Dims == AnyDims ? 4 : std::max(Dims, 1))>
template<typename Fn , typename... Args, int N = sizeof...(Args) + 1>

HALIDE_ALWAYS_INLINE Buffer< T, Dims, InClassDimStorage > & Halide::Runtime::Buffer< T, Dims, InClassDimStorage >::for_each_value | ( | Fn && | f,
|  | Args &&... | other_buffers
| ) |  |
| inline

Definition at line 2347 of file HalideBuffer.h.

## ◆ for_each_element() [1/2]

template<typename T = void, int Dims = AnyDims, int InClassDimStorage = (Dims == AnyDims ? 4 : std::max(Dims, 1))>
template<typename Fn >

HALIDE_ALWAYS_INLINE const Buffer< T, Dims, InClassDimStorage > & Halide::Runtime::Buffer< T, Dims, InClassDimStorage >::for_each_element | ( | Fn && | f | ) | const
| inline

Call a function at each site in a buffer.

This is likely to be much slower than using Halide code to populate a buffer, but is convenient for tests. If the function has more arguments than the buffer has dimensions, the remaining arguments will be zero. If it has fewer arguments than the buffer has dimensions then the last few dimensions of the buffer are not iterated over. For example, the following code exploits this to set a floating point RGB image to red:

Buffer<float, 3> im(100, 100, 3);
im.for_each_element([&](int x, int y) {
im(x, y, 0) = 1.0f;
im(x, y, 1) = 0.0f;
im(x, y, 2) = 0.0f:
});

The compiled code is equivalent to writing the a nested for loop, and compilers are capable of optimizing it in the same way.

If the callable can be called with an int * as the sole argument, that version is called instead. Each location in the buffer is passed to it in a coordinate array. This version is higher-overhead than the variadic version, but is useful for writing generic code that accepts buffers of arbitrary dimensionality. For example, the following sets the value at all sites in an arbitrary-dimensional buffer to their first coordinate:

im.for_each_element([&](const int *pos) {im(pos) = pos[0];});

It is also possible to use for_each_element to iterate over entire rows or columns by cropping the buffer to a single column or row respectively and iterating over elements of the result. For example, to set the diagonal of the image to 1 by iterating over the columns:

Buffer<float, 3> im(100, 100, 3);
im.sliced(1, 0).for_each_element([&](int x, int c) {
im(x, x, c) = 1.0f;
});

Or, assuming the memory layout is known to be dense per row, one can memset each row of an image like so:

Buffer<float, 3> im(100, 100, 3);
im.sliced(0, 0).for_each_element([&](int y, int c) {
memset(&im(0, y, c), 0, sizeof(float) * im.width());
});
memset
void * memset(void *s, int val, size_t n)

Definition at line 2542 of file HalideBuffer.h.

## ◆ for_each_element() [2/2]

template<typename T = void, int Dims = AnyDims, int InClassDimStorage = (Dims == AnyDims ? 4 : std::max(Dims, 1))>
template<typename Fn >

HALIDE_ALWAYS_INLINE Buffer< T, Dims, InClassDimStorage > & Halide::Runtime::Buffer< T, Dims, InClassDimStorage >::for_each_element | ( | Fn && | f | ) |
| inline

Definition at line 2550 of file HalideBuffer.h.

## ◆ fill() [2/2]

template<typename T = void, int Dims = AnyDims, int InClassDimStorage = (Dims == AnyDims ? 4 : std::max(Dims, 1))>
template<typename Fn , typename = std::enable_if_t<!std::is_arithmetic_v<std::decay_t<Fn>>>>

Buffer< T, Dims, InClassDimStorage > & Halide::Runtime::Buffer< T, Dims, InClassDimStorage >::fill | ( | Fn && | f | ) |
| inline

Fill a buffer by evaluating a callable at every site.

The callable should look much like a callable passed to for_each_element, but it should return the value that should be stored to the coordinate corresponding to the arguments.

Definition at line 2580 of file HalideBuffer.h.

## ◆ is_bounds_query()

template<typename T = void, int Dims = AnyDims, int InClassDimStorage = (Dims == AnyDims ? 4 : std::max(Dims, 1))>

bool Halide::Runtime::Buffer< T, Dims, InClassDimStorage >::is_bounds_query | ( |  | ) | const
| inline

Check if an input buffer passed extern stage is a querying bounds.

Compared to doing the host pointer check directly, this both adds clarity to code and will facilitate moving to another representation for bounds query arguments.

Definition at line 2590 of file HalideBuffer.h.

## ◆ msan_check_mem_is_initialized()

template<typename T = void, int Dims = AnyDims, int InClassDimStorage = (Dims == AnyDims ? 4 : std::max(Dims, 1))>

void Halide::Runtime::Buffer< T, Dims, InClassDimStorage >::msan_check_mem_is_initialized | ( | bool | entire = `false` | ) | const
| inline

Convenient check to verify that all of the interesting bytes in the Buffer are initialized under MSAN.

Note that by default, we use for_each_value() here so that we skip any unused padding that isn't part of the Buffer; this isn't efficient, but in MSAN mode, it doesn't matter. (Pass true for the flag to force check the entire Buffer storage.)

Definition at line 2599 of file HalideBuffer.h.

## Member Data Documentation

## ◆ has_static_halide_type

template<typename T = void, int Dims = AnyDims, int InClassDimStorage = (Dims == AnyDims ? 4 : std::max(Dims, 1))>

constexpr bool Halide::Runtime::Buffer< T, Dims, InClassDimStorage >::has_static_halide_type = !T_is_void
| static constexpr

True if the Halide type is not void (or const void).

Definition at line 263 of file HalideBuffer.h.

## ◆ has_static_dimensions

template<typename T = void, int Dims = AnyDims, int InClassDimStorage = (Dims == AnyDims ? 4 : std::max(Dims, 1))>

constexpr bool Halide::Runtime::Buffer< T, Dims, InClassDimStorage >::has_static_dimensions = (Dims != AnyDims)
| static constexpr

Definition at line 276 of file HalideBuffer.h.

The documentation for this class was generated from the following file:

- src/runtime/HalideBuffer.h